"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.localeMenu = exports.clearspeakMenu = void 0;
var MJContextMenu_js_1 = require("../ui/menu/MJContextMenu.js");
var sre_js_1 = require("./sre.js");
var csPrefsSetting = {};
function csPrefsVariables(menu, prefs) {
    var e_1, _a;
    var srVariable = menu.pool.lookup('speechRules');
    var previous = sre_js_1.Sre.clearspeakPreferences.currentPreference();
    csPrefsSetting = sre_js_1.Sre.clearspeakPreferences.fromPreference(previous);
    var _loop_1 = function (pref) {
        menu.factory.get('variable')(menu.factory, {
            name: 'csprf_' + pref,
            setter: function (value) {
                csPrefsSetting[pref] = value;
                srVariable.setValue('clearspeak-' +
                    sre_js_1.Sre.clearspeakPreferences.toPreference(csPrefsSetting));
            },
            getter: function () { return csPrefsSetting[pref] || 'Auto'; }
        }, menu.pool);
    };
    try {
        for (var prefs_1 = __values(prefs), prefs_1_1 = prefs_1.next(); !prefs_1_1.done; prefs_1_1 = prefs_1.next()) {
            var pref = prefs_1_1.value;
            _loop_1(pref);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (prefs_1_1 && !prefs_1_1.done && (_a = prefs_1.return)) _a.call(prefs_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
}
function csSelectionBox(menu, locale) {
    var e_2, _a;
    var prefs = sre_js_1.Sre.clearspeakPreferences.getLocalePreferences();
    var props = prefs[locale];
    if (!props) {
        var csEntry = menu.findID('Accessibility', 'Speech', 'Clearspeak');
        if (csEntry) {
            csEntry.disable();
        }
        return null;
    }
    csPrefsVariables(menu, Object.keys(props));
    var items = [];
    var _loop_2 = function (prop) {
        items.push({
            'title': prop,
            'values': props[prop].map(function (x) { return x.replace(RegExp('^' + prop + '_'), ''); }),
            'variable': 'csprf_' + prop
        });
    };
    try {
        for (var _b = __values(Object.getOwnPropertyNames(props)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var prop = _c.value;
            _loop_2(prop);
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_2) throw e_2.error; }
    }
    var sb = menu.factory.get('selectionBox')(menu.factory, {
        'title': 'Clearspeak Preferences',
        'signature': '',
        'order': 'alphabetic',
        'grid': 'square',
        'selections': items
    }, menu);
    return { 'type': 'command',
        'id': 'ClearspeakPreferences',
        'content': 'Select Preferences',
        'action': function () { return sb.post(0, 0); } };
}
function basePreferences(previous) {
    var items = [
        {
            type: 'radio',
            content: 'No Preferences',
            id: 'clearspeak-default',
            variable: 'speechRules'
        },
        {
            type: 'radio',
            content: 'Current Preferences',
            id: 'clearspeak-' + previous,
            variable: 'speechRules'
        },
        {
            type: 'rule'
        },
    ];
    return items;
}
function smartPreferences(previous, smart, locale) {
    var prefs = sre_js_1.Sre.clearspeakPreferences.getLocalePreferences();
    var loc = prefs[locale];
    if (!loc) {
        return [];
    }
    var items = [
        { type: 'label', content: 'Preferences for ' + smart },
        { type: 'rule' }
    ];
    return items.concat(loc[smart].map(function (x) {
        var _a = __read(x.split('_'), 2), key = _a[0], value = _a[1];
        return {
            type: 'radioCompare',
            content: value,
            id: 'clearspeak-' + sre_js_1.Sre.clearspeakPreferences.addPreference(previous, key, value),
            variable: 'speechRules',
            comparator: function (x, y) {
                if (x === y) {
                    return true;
                }
                if (value !== 'Auto') {
                    return false;
                }
                var _a = __read(x.split('-'), 2), dom1 = _a[0], pref = _a[1];
                var _b = __read(y.split('-'), 1), dom2 = _b[0];
                return dom1 === dom2 && !sre_js_1.Sre.clearspeakPreferences.fromPreference(pref)[key];
            }
        };
    }));
}
function clearspeakMenu(menu, sub) {
    var _a, _b, _c, _d;
    var locale = menu.pool.lookup('locale').getValue();
    var box = csSelectionBox(menu, locale);
    var items = [];
    var explorer = (_c = (_b = (_a = menu.mathItem) === null || _a === void 0 ? void 0 : _a.explorers) === null || _b === void 0 ? void 0 : _b.explorers) === null || _c === void 0 ? void 0 : _c.speech;
    if (explorer === null || explorer === void 0 ? void 0 : explorer.walker) {
        var semantic = (_d = explorer.walker.getFocus()) === null || _d === void 0 ? void 0 : _d.getSemanticPrimary();
        if (semantic) {
            var previous = sre_js_1.Sre.clearspeakPreferences.currentPreference();
            var smart = sre_js_1.Sre.clearspeakPreferences.relevantPreferences(semantic);
            items = items.concat(basePreferences(previous));
            items = items.concat(smartPreferences(previous, smart, locale));
        }
    }
    if (box) {
        items.splice(2, 0, box);
    }
    return menu.factory.get('subMenu')(menu.factory, {
        items: items,
        id: 'Clearspeak'
    }, sub);
}
exports.clearspeakMenu = clearspeakMenu;
MJContextMenu_js_1.MJContextMenu.DynamicSubmenus.set('Clearspeak', clearspeakMenu);
var LOCALE_MENU = null;
function localeMenu(menu, sub) {
    var e_3, _a;
    if (LOCALE_MENU) {
        return LOCALE_MENU;
    }
    var radios = [];
    try {
        for (var _b = __values(sre_js_1.Sre.locales.keys()), _c = _b.next(); !_c.done; _c = _b.next()) {
            var lang = _c.value;
            if (lang === 'nemeth' || lang === 'euro')
                continue;
            radios.push({ type: 'radio', id: lang,
                content: sre_js_1.Sre.locales.get(lang) || lang, variable: 'locale' });
        }
    }
    catch (e_3_1) { e_3 = { error: e_3_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_3) throw e_3.error; }
    }
    radios.sort(function (x, y) { return x.content.localeCompare(y.content, 'en'); });
    LOCALE_MENU = menu.factory.get('subMenu')(menu.factory, {
        items: radios, id: 'Language'
    }, sub);
    return LOCALE_MENU;
}
exports.localeMenu = localeMenu;
MJContextMenu_js_1.MJContextMenu.DynamicSubmenus.set('A11yLanguage', localeMenu);
//# sourceMappingURL=SpeechMenu.js.map