"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExplorerPool = exports.RegionPool = void 0;
var Region_js_1 = require("./Region.js");
var ke = __importStar(require("./KeyExplorer.js"));
var me = __importStar(require("./MouseExplorer.js"));
var TreeExplorer_js_1 = require("./TreeExplorer.js");
var sre_js_1 = require("../sre.js");
var RegionPool = (function () {
    function RegionPool(document) {
        this.document = document;
        this.speechRegion = new Region_js_1.SpeechRegion(this.document);
        this.brailleRegion = new Region_js_1.LiveRegion(this.document);
        this.magnifier = new Region_js_1.HoverRegion(this.document);
        this.tooltip1 = new Region_js_1.ToolTip(this.document);
        this.tooltip2 = new Region_js_1.ToolTip(this.document);
        this.tooltip3 = new Region_js_1.ToolTip(this.document);
    }
    return RegionPool;
}());
exports.RegionPool = RegionPool;
var allExplorers = {
    speech: function (doc, pool, node) {
        var _a;
        var rest = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            rest[_i - 3] = arguments[_i];
        }
        var explorer = (_a = ke.SpeechExplorer).create.apply(_a, __spreadArray([doc, pool, doc.explorerRegions.speechRegion, node], __read(rest), false));
        explorer.speechGenerator.setOptions({
            automark: true, markup: 'ssml',
            locale: doc.options.sre.locale, domain: doc.options.sre.domain,
            style: doc.options.sre.style, modality: 'speech'
        });
        var locale = explorer.speechGenerator.getOptions().locale;
        if (locale !== sre_js_1.Sre.engineSetup().locale) {
            doc.options.sre.locale = sre_js_1.Sre.engineSetup().locale;
            explorer.speechGenerator.setOptions({ locale: doc.options.sre.locale });
        }
        explorer.sound = true;
        explorer.showRegion = 'subtitles';
        return explorer;
    },
    braille: function (doc, pool, node) {
        var _a;
        var rest = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            rest[_i - 3] = arguments[_i];
        }
        var explorer = (_a = ke.SpeechExplorer).create.apply(_a, __spreadArray([doc, pool, doc.explorerRegions.brailleRegion, node], __read(rest), false));
        explorer.speechGenerator.setOptions({ automark: false, markup: 'none',
            locale: 'nemeth', domain: 'default',
            style: 'default', modality: 'braille' });
        explorer.showRegion = 'viewBraille';
        return explorer;
    },
    keyMagnifier: function (doc, pool, node) {
        var _a;
        var rest = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            rest[_i - 3] = arguments[_i];
        }
        return (_a = ke.Magnifier).create.apply(_a, __spreadArray([doc, pool, doc.explorerRegions.magnifier, node], __read(rest), false));
    },
    mouseMagnifier: function (doc, pool, node) {
        var _rest = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            _rest[_i - 3] = arguments[_i];
        }
        return me.ContentHoverer.create(doc, pool, doc.explorerRegions.magnifier, node, function (x) { return x.hasAttribute('data-semantic-type'); }, function (x) { return x; });
    },
    hover: function (doc, pool, node) {
        var _rest = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            _rest[_i - 3] = arguments[_i];
        }
        return me.FlameHoverer.create(doc, pool, null, node);
    },
    infoType: function (doc, pool, node) {
        var _rest = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            _rest[_i - 3] = arguments[_i];
        }
        return me.ValueHoverer.create(doc, pool, doc.explorerRegions.tooltip1, node, function (x) { return x.hasAttribute('data-semantic-type'); }, function (x) { return x.getAttribute('data-semantic-type'); });
    },
    infoRole: function (doc, pool, node) {
        var _rest = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            _rest[_i - 3] = arguments[_i];
        }
        return me.ValueHoverer.create(doc, pool, doc.explorerRegions.tooltip2, node, function (x) { return x.hasAttribute('data-semantic-role'); }, function (x) { return x.getAttribute('data-semantic-role'); });
    },
    infoPrefix: function (doc, pool, node) {
        var _rest = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            _rest[_i - 3] = arguments[_i];
        }
        return me.ValueHoverer.create(doc, pool, doc.explorerRegions.tooltip3, node, function (x) { return x.hasAttribute('data-semantic-prefix'); }, function (x) { return x.getAttribute('data-semantic-prefix'); });
    },
    flame: function (doc, pool, node) {
        var _rest = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            _rest[_i - 3] = arguments[_i];
        }
        return TreeExplorer_js_1.FlameColorer.create(doc, pool, null, node);
    },
    treeColoring: function (doc, pool, node) {
        var rest = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            rest[_i - 3] = arguments[_i];
        }
        return TreeExplorer_js_1.TreeColorer.create.apply(TreeExplorer_js_1.TreeColorer, __spreadArray([doc, pool, null, node], __read(rest), false));
    }
};
var ExplorerPool = (function () {
    function ExplorerPool() {
        this.explorers = {};
        this.attached = [];
        this._restart = [];
    }
    Object.defineProperty(ExplorerPool.prototype, "highlighter", {
        get: function () {
            if (this._renderer !== this.document.outputJax.name) {
                this._renderer = this.document.outputJax.name;
                this.setPrimaryHighlighter();
                return this._highlighter;
            }
            var _a = __read(this.colorOptions(), 2), foreground = _a[0], background = _a[1];
            sre_js_1.Sre.updateHighlighter(background, foreground, this._highlighter);
            return this._highlighter;
        },
        enumerable: false,
        configurable: true
    });
    ExplorerPool.prototype.init = function (document, node, mml) {
        var e_1, _a;
        this.document = document;
        this.mml = mml;
        this.node = node;
        this.setPrimaryHighlighter();
        try {
            for (var _b = __values(Object.keys(allExplorers)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var key = _c.value;
                this.explorers[key] = allExplorers[key](this.document, this, this.node, this.mml);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this.setSecondaryHighlighter();
        this.attach();
    };
    ExplorerPool.prototype.attach = function () {
        var e_2, _a, e_3, _b;
        this.attached = [];
        var keyExplorers = [];
        try {
            for (var _c = __values(Object.keys(this.explorers)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var key = _d.value;
                var explorer = this.explorers[key];
                if (explorer instanceof ke.AbstractKeyExplorer) {
                    explorer.AddEvents();
                    explorer.stoppable = false;
                    keyExplorers.unshift(explorer);
                }
                if (this.document.options.a11y[key]) {
                    explorer.Attach();
                    this.attached.push(key);
                }
                else {
                    explorer.Detach();
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_2) throw e_2.error; }
        }
        try {
            for (var keyExplorers_1 = __values(keyExplorers), keyExplorers_1_1 = keyExplorers_1.next(); !keyExplorers_1_1.done; keyExplorers_1_1 = keyExplorers_1.next()) {
                var explorer = keyExplorers_1_1.value;
                if (explorer.attached) {
                    explorer.stoppable = true;
                    break;
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (keyExplorers_1_1 && !keyExplorers_1_1.done && (_b = keyExplorers_1.return)) _b.call(keyExplorers_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
    };
    ExplorerPool.prototype.reattach = function () {
        var e_4, _a;
        try {
            for (var _b = __values(this.attached), _c = _b.next(); !_c.done; _c = _b.next()) {
                var key = _c.value;
                var explorer = this.explorers[key];
                if (explorer.active) {
                    this._restart.push(key);
                    explorer.Stop();
                }
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_4) throw e_4.error; }
        }
    };
    ExplorerPool.prototype.restart = function () {
        var _this = this;
        this._restart.forEach(function (x) { return _this.explorers[x].Start(); });
        this._restart = [];
    };
    ExplorerPool.prototype.setPrimaryHighlighter = function () {
        var _a = __read(this.colorOptions(), 2), foreground = _a[0], background = _a[1];
        this._highlighter = sre_js_1.Sre.getHighlighter(background, foreground, { renderer: this.document.outputJax.name, browser: 'v3' });
    };
    ExplorerPool.prototype.setSecondaryHighlighter = function () {
        this.secondaryHighlighter = sre_js_1.Sre.getHighlighter({ color: 'red' }, { color: 'black' }, { renderer: this.document.outputJax.name, browser: 'v3' });
        this.explorers['speech'].region.highlighter =
            this.secondaryHighlighter;
    };
    ExplorerPool.prototype.highlight = function (nodes) {
        this.highlighter.highlight(nodes);
    };
    ExplorerPool.prototype.unhighlight = function () {
        this.secondaryHighlighter.unhighlight();
        this.highlighter.unhighlight();
    };
    ExplorerPool.prototype.colorOptions = function () {
        var opts = this.document.options.a11y;
        var foreground = { color: opts.foregroundColor.toLowerCase(),
            alpha: opts.foregroundOpacity / 100 };
        var background = { color: opts.backgroundColor.toLowerCase(),
            alpha: opts.backgroundOpacity / 100 };
        return [foreground, background];
    };
    return ExplorerPool;
}());
exports.ExplorerPool = ExplorerPool;
//# sourceMappingURL=ExplorerPool.js.map