"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var _a, _b, _c;
Object.defineProperty(exports, "__esModule", { value: true });
exports.HoverRegion = exports.SpeechRegion = exports.LiveRegion = exports.ToolTip = exports.StringRegion = exports.DummyRegion = exports.AbstractRegion = void 0;
var StyleList_js_1 = require("../../util/StyleList.js");
var sre_js_1 = require("../sre.js");
var AbstractRegion = exports.AbstractRegion = (function () {
    function AbstractRegion(document) {
        this.document = document;
        this.CLASS = this.constructor;
        this.AddStyles();
        this.AddElement();
    }
    AbstractRegion.prototype.AddStyles = function () {
        if (this.CLASS.styleAdded) {
            return;
        }
        var node = this.document.adaptor.node('style');
        node.innerHTML = this.CLASS.style.cssText;
        this.document.adaptor.head(this.document.adaptor.document).
            appendChild(node);
        this.CLASS.styleAdded = true;
    };
    AbstractRegion.prototype.AddElement = function () {
        var element = this.document.adaptor.node('div');
        element.classList.add(this.CLASS.className);
        element.style.backgroundColor = 'white';
        this.div = element;
        this.inner = this.document.adaptor.node('div');
        this.div.appendChild(this.inner);
        this.document.adaptor.
            body(this.document.adaptor.document).
            appendChild(this.div);
    };
    AbstractRegion.prototype.Show = function (node, highlighter) {
        this.position(node);
        this.highlight(highlighter);
        this.div.classList.add(this.CLASS.className + '_Show');
    };
    AbstractRegion.prototype.Hide = function () {
        this.div.classList.remove(this.CLASS.className + '_Show');
    };
    AbstractRegion.prototype.stackRegions = function (node) {
        var rect = node.getBoundingClientRect();
        var baseBottom = 0;
        var baseLeft = Number.POSITIVE_INFINITY;
        var regions = this.document.adaptor.document.getElementsByClassName(this.CLASS.className + '_Show');
        for (var i = 0, region = void 0; region = regions[i]; i++) {
            if (region !== this.div) {
                baseBottom = Math.max(region.getBoundingClientRect().bottom, baseBottom);
                baseLeft = Math.min(region.getBoundingClientRect().left, baseLeft);
            }
        }
        var bot = (baseBottom ? baseBottom : rect.bottom + 10) + window.pageYOffset;
        var left = (baseLeft < Number.POSITIVE_INFINITY ? baseLeft : rect.left) + window.pageXOffset;
        this.div.style.top = bot + 'px';
        this.div.style.left = left + 'px';
    };
    AbstractRegion.styleAdded = false;
    return AbstractRegion;
}());
var DummyRegion = (function (_super) {
    __extends(DummyRegion, _super);
    function DummyRegion() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DummyRegion.prototype.Clear = function () { };
    DummyRegion.prototype.Update = function () { };
    DummyRegion.prototype.Hide = function () { };
    DummyRegion.prototype.Show = function () { };
    DummyRegion.prototype.AddElement = function () { };
    DummyRegion.prototype.AddStyles = function () { };
    DummyRegion.prototype.position = function () { };
    DummyRegion.prototype.highlight = function (_highlighter) { };
    return DummyRegion;
}(AbstractRegion));
exports.DummyRegion = DummyRegion;
var StringRegion = (function (_super) {
    __extends(StringRegion, _super);
    function StringRegion() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StringRegion.prototype.Clear = function () {
        this.Update('');
        this.inner.style.top = '';
        this.inner.style.backgroundColor = '';
    };
    StringRegion.prototype.Update = function (speech) {
        this.inner.textContent = '';
        this.inner.textContent = speech;
    };
    StringRegion.prototype.position = function (node) {
        this.stackRegions(node);
    };
    StringRegion.prototype.highlight = function (highlighter) {
        var color = highlighter.colorString();
        this.inner.style.backgroundColor = color.background;
        this.inner.style.color = color.foreground;
    };
    return StringRegion;
}(AbstractRegion));
exports.StringRegion = StringRegion;
var ToolTip = exports.ToolTip = (function (_super) {
    __extends(ToolTip, _super);
    function ToolTip() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ToolTip.className = 'MJX_ToolTip';
    ToolTip.style = new StyleList_js_1.CssStyles((_a = {},
        _a['.' + ToolTip.className] = {
            position: 'absolute', display: 'inline-block',
            height: '1px', width: '1px'
        },
        _a['.' + ToolTip.className + '_Show'] = {
            width: 'auto', height: 'auto', opacity: 1, 'text-align': 'center',
            'border-radius': '6px', padding: '0px 0px',
            'border-bottom': '1px dotted black', position: 'absolute',
            'z-index': 202
        },
        _a));
    return ToolTip;
}(StringRegion));
var LiveRegion = exports.LiveRegion = (function (_super) {
    __extends(LiveRegion, _super);
    function LiveRegion(document) {
        var _this = _super.call(this, document) || this;
        _this.document = document;
        _this.div.setAttribute('aria-live', 'assertive');
        return _this;
    }
    LiveRegion.className = 'MJX_LiveRegion';
    LiveRegion.style = new StyleList_js_1.CssStyles((_b = {},
        _b['.' + LiveRegion.className] = {
            position: 'absolute', top: '0', height: '1px', width: '1px',
            padding: '1px', overflow: 'hidden'
        },
        _b['.' + LiveRegion.className + '_Show'] = {
            top: '0', position: 'absolute', width: 'auto', height: 'auto',
            padding: '0px 0px', opacity: 1, 'z-index': '202',
            left: 0, right: 0, 'margin': '0 auto',
            'background-color': 'rgba(0, 0, 255, 0.2)', 'box-shadow': '0px 5px 20px #888',
            border: '2px solid #CCCCCC'
        },
        _b));
    return LiveRegion;
}(StringRegion));
var ProsodyKeys = ['pitch', 'rate', 'volume'];
var SpeechRegion = exports.SpeechRegion = (function (_super) {
    __extends(SpeechRegion, _super);
    function SpeechRegion() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.active = false;
        _this.node = null;
        _this.clear = false;
        _this.highlighter = sre_js_1.Sre.getHighlighter({ color: 'red' }, { color: 'black' }, { renderer: _this.document.outputJax.name, browser: 'v3' });
        return _this;
    }
    SpeechRegion.prototype.Show = function (node, highlighter) {
        this.node = node;
        _super.prototype.Show.call(this, node, highlighter);
    };
    SpeechRegion.prototype.Update = function (speech) {
        var _a;
        this.active = this.document.options.a11y.voicing &&
            !!speechSynthesis.getVoices().length;
        speechSynthesis.cancel();
        this.clear = true;
        var text = (_a = __read(this.ssmlParsing(speech), 2), _a[0]), ssml = _a[1];
        _super.prototype.Update.call(this, text);
        if (this.active && text) {
            this.makeUtterances(ssml, this.document.options.sre.locale);
        }
    };
    SpeechRegion.prototype.makeUtterances = function (ssml, locale) {
        var e_1, _a;
        var _this = this;
        var utterance = null;
        var _loop_1 = function (utter) {
            if (utter.mark) {
                if (!utterance) {
                    this_1.highlightNode(utter.mark, true);
                    return "continue";
                }
                utterance.addEventListener('end', function (_event) {
                    _this.highlightNode(utter.mark);
                });
                return "continue";
            }
            if (utter.pause) {
                var time_1 = parseInt(utter.pause.match(/^[0-9]+/)[0]);
                if (isNaN(time_1) || !utterance) {
                    return "continue";
                }
                utterance.addEventListener('end', function (_event) {
                    speechSynthesis.pause();
                    setTimeout(function () {
                        speechSynthesis.resume();
                    }, time_1);
                });
                return "continue";
            }
            utterance = new SpeechSynthesisUtterance(utter.text);
            if (utter.rate) {
                utterance.rate = utter.rate;
            }
            if (utter.pitch) {
                utterance.pitch = utter.pitch;
            }
            utterance.lang = locale;
            speechSynthesis.speak(utterance);
        };
        var this_1 = this;
        try {
            for (var ssml_1 = __values(ssml), ssml_1_1 = ssml_1.next(); !ssml_1_1.done; ssml_1_1 = ssml_1.next()) {
                var utter = ssml_1_1.value;
                _loop_1(utter);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (ssml_1_1 && !ssml_1_1.done && (_a = ssml_1.return)) _a.call(ssml_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (utterance) {
            utterance.addEventListener('end', function (_event) {
                _this.highlighter.unhighlight();
            });
        }
    };
    SpeechRegion.prototype.highlightNode = function (id, init) {
        if (init === void 0) { init = false; }
        this.highlighter.unhighlight();
        var nodes = Array.from(this.node.querySelectorAll("[data-semantic-id=\"".concat(id, "\"]")));
        if (!this.clear || init) {
            this.highlighter.highlight(nodes);
        }
        this.clear = false;
    };
    SpeechRegion.prototype.ssmlParsing = function (speech) {
        var dp = new DOMParser();
        var xml = dp.parseFromString(speech, 'text/xml');
        var instr = [];
        var text = [];
        this.recurseSsml(Array.from(xml.documentElement.childNodes), instr, text);
        return [text.join(' '), instr];
    };
    SpeechRegion.prototype.recurseSsml = function (nodes, instr, text, prosody) {
        var e_2, _a;
        if (prosody === void 0) { prosody = {}; }
        try {
            for (var nodes_1 = __values(nodes), nodes_1_1 = nodes_1.next(); !nodes_1_1.done; nodes_1_1 = nodes_1.next()) {
                var node = nodes_1_1.value;
                if (node.nodeType === 3) {
                    var content = node.textContent.trim();
                    if (content) {
                        text.push(content);
                        instr.push(Object.assign({ text: content }, prosody));
                    }
                    continue;
                }
                if (node.nodeType === 1) {
                    var element = node;
                    var tag = element.tagName;
                    if (tag === 'speak') {
                        continue;
                    }
                    if (tag === 'prosody') {
                        this.recurseSsml(Array.from(node.childNodes), instr, text, this.getProsody(element, prosody));
                        continue;
                    }
                    switch (tag) {
                        case 'break':
                            instr.push({ pause: element.getAttribute('time') });
                            break;
                        case 'mark':
                            instr.push({ mark: element.getAttribute('name') });
                            break;
                        case 'say-as':
                            var txt = element.textContent;
                            instr.push(Object.assign({ text: txt, character: true }, prosody));
                            text.push(txt);
                            break;
                        default:
                            break;
                    }
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (nodes_1_1 && !nodes_1_1.done && (_a = nodes_1.return)) _a.call(nodes_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    SpeechRegion.prototype.getProsody = function (element, prosody) {
        var e_3, _a, _b;
        var combine = {};
        try {
            for (var ProsodyKeys_1 = __values(ProsodyKeys), ProsodyKeys_1_1 = ProsodyKeys_1.next(); !ProsodyKeys_1_1.done; ProsodyKeys_1_1 = ProsodyKeys_1.next()) {
                var pros = ProsodyKeys_1_1.value;
                if (element.hasAttribute(pros)) {
                    var sign = (_b = __read(SpeechRegion.extractProsody(element.getAttribute(pros)), 2), _b[0]), value = _b[1];
                    if (!sign) {
                        combine[pros] = (pros === 'volume') ? .5 : 1;
                        continue;
                    }
                    var orig = prosody[pros];
                    orig = orig ? orig : ((pros === 'volume') ? .5 : 1);
                    var relative = SpeechRegion.combinePros[pros](parseInt(value, 10), sign);
                    combine[pros] = (sign === '-') ? orig - relative : orig + relative;
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (ProsodyKeys_1_1 && !ProsodyKeys_1_1.done && (_a = ProsodyKeys_1.return)) _a.call(ProsodyKeys_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return combine;
    };
    SpeechRegion.extractProsody = function (attr) {
        var match = attr.match(SpeechRegion.prosodyRegexp);
        if (!match) {
            console.warn('Something went wrong with the prosody matching.');
            return ['', '100'];
        }
        return [match[1], match[2]];
    };
    SpeechRegion.combinePros = {
        pitch: function (x, _sign) { return 1 * (x / 100); },
        volume: function (x, _sign) { return .5 * (x / 100); },
        rate: function (x, _sign) { return 1 * (x / 100); }
    };
    SpeechRegion.prosodyRegexp = /([\+|-]*)([0-9]+)%/;
    return SpeechRegion;
}(LiveRegion));
var HoverRegion = exports.HoverRegion = (function (_super) {
    __extends(HoverRegion, _super);
    function HoverRegion(document) {
        var _this = _super.call(this, document) || this;
        _this.document = document;
        _this.inner.style.lineHeight = '0';
        return _this;
    }
    HoverRegion.prototype.position = function (node) {
        var nodeRect = node.getBoundingClientRect();
        var divRect = this.div.getBoundingClientRect();
        var xCenter = nodeRect.left + (nodeRect.width / 2);
        var left = xCenter - (divRect.width / 2);
        left = (left < 0) ? 0 : left;
        left = left + window.pageXOffset;
        var top;
        switch (this.document.options.a11y.align) {
            case 'top':
                top = nodeRect.top - divRect.height - 10;
                break;
            case 'bottom':
                top = nodeRect.bottom + 10;
                break;
            case 'center':
            default:
                var yCenter = nodeRect.top + (nodeRect.height / 2);
                top = yCenter - (divRect.height / 2);
        }
        top = top + window.pageYOffset;
        top = (top < 0) ? 0 : top;
        this.div.style.top = top + 'px';
        this.div.style.left = left + 'px';
    };
    HoverRegion.prototype.highlight = function (highlighter) {
        if (this.inner.firstChild &&
            !this.inner.firstChild.hasAttribute('sre-highlight')) {
            return;
        }
        var color = highlighter.colorString();
        this.inner.style.backgroundColor = color.background;
        this.inner.style.color = color.foreground;
    };
    HoverRegion.prototype.Show = function (node, highlighter) {
        this.div.style.fontSize = this.document.options.a11y.magnify;
        this.Update(node);
        _super.prototype.Show.call(this, node, highlighter);
    };
    HoverRegion.prototype.Clear = function () {
        this.inner.textContent = '';
        this.inner.style.top = '';
        this.inner.style.backgroundColor = '';
    };
    HoverRegion.prototype.Update = function (node) {
        this.Clear();
        var mjx = this.cloneNode(node);
        this.inner.appendChild(mjx);
    };
    HoverRegion.prototype.cloneNode = function (node) {
        var _a;
        var mjx = node.cloneNode(true);
        if (mjx.nodeName !== 'MJX-CONTAINER') {
            if (mjx.nodeName !== 'g') {
                mjx.style.marginLeft = mjx.style.marginRight = '0';
            }
            var container = node;
            while (container && container.nodeName !== 'MJX-CONTAINER') {
                container = container.parentNode;
            }
            if (mjx.nodeName !== 'MJX-MATH' && mjx.nodeName !== 'svg') {
                var child = container.firstChild;
                mjx = child.cloneNode(false).appendChild(mjx).parentNode;
                if (mjx.nodeName === 'svg') {
                    mjx.firstChild.setAttribute('transform', 'matrix(1 0 0 -1 0 0)');
                    var W = parseFloat(mjx.getAttribute('viewBox').split(/ /)[2]);
                    var w = parseFloat(mjx.getAttribute('width'));
                    var x = (_a = node.getBBox(), _a.x), y = _a.y, width = _a.width, height = _a.height;
                    mjx.setAttribute('viewBox', [x, -(y + height), width, height].join(' '));
                    mjx.removeAttribute('style');
                    mjx.setAttribute('width', (w / W * width) + 'ex');
                    mjx.setAttribute('height', (w / W * height) + 'ex');
                    container.setAttribute('sre-highlight', 'false');
                }
            }
            mjx = container.cloneNode(false).appendChild(mjx).parentNode;
            mjx.style.margin = '0';
        }
        return mjx;
    };
    HoverRegion.className = 'MJX_HoverRegion';
    HoverRegion.style = new StyleList_js_1.CssStyles((_c = {},
        _c['.' + HoverRegion.className] = {
            position: 'absolute', height: '1px', width: '1px',
            padding: '1px', overflow: 'hidden'
        },
        _c['.' + HoverRegion.className + '_Show'] = {
            position: 'absolute', width: 'max-content', height: 'auto',
            padding: '0px 0px', opacity: 1, 'z-index': '202', 'margin': '0 auto',
            'background-color': 'rgba(0, 0, 255, 0.2)',
            'box-shadow': '0px 10px 20px #888', border: '2px solid #CCCCCC'
        },
        _c));
    return HoverRegion;
}(AbstractRegion));
//# sourceMappingURL=Region.js.map