"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChtmlInferredMrow = exports.ChtmlMrow = void 0;
var Wrapper_js_1 = require("../Wrapper.js");
var mrow_js_1 = require("../../common/Wrappers/mrow.js");
var mrow_js_2 = require("../../common/Wrappers/mrow.js");
var mrow_js_3 = require("../../../core/MmlTree/MmlNodes/mrow.js");
exports.ChtmlMrow = (function () {
    var _a;
    var Base = (0, mrow_js_1.CommonMrowMixin)(Wrapper_js_1.ChtmlWrapper);
    return _a = (function (_super) {
            __extends(ChtmlMrow, _super);
            function ChtmlMrow() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.linebreakCount = 0;
                return _this;
            }
            ChtmlMrow.prototype.toCHTML = function (parents) {
                var n = this.linebreakCount = (this.isStack ? 0 : this.breakCount);
                if (n || !this.node.isInferred) {
                    parents = this.standardChtmlNodes(parents);
                }
                else {
                    this.dom = parents;
                }
                this.addChildren(parents);
                if (n) {
                    this.placeLines(parents, n);
                }
                else {
                    this.handleVerticalAlign(parents[0]);
                    this.handleNegativeWidth(parents[0]);
                }
            };
            ChtmlMrow.prototype.placeLines = function (parents, n) {
                var e_1, _a;
                var _b, _c;
                this.getBBox();
                var lines = this.lineBBox;
                var adaptor = this.adaptor;
                var _d = __read(((_b = lines[1].indentData) === null || _b === void 0 ? void 0 : _b[0]) || ['left', '0'], 2), alignfirst = _d[0], shiftfirst = _d[1];
                try {
                    for (var _e = __values(parents.keys()), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var i = _f.value;
                        var bbox = lines[i];
                        var _g = __read((i === 0 ?
                            [alignfirst, shiftfirst] :
                            ((_c = bbox.indentData) === null || _c === void 0 ? void 0 : _c[i === n ? 2 : 1]) || ['left', '0']), 2), indentalign = _g[0], indentshift = _g[1];
                        var _h = __read(this.processIndent(indentalign, indentshift, alignfirst, shiftfirst), 2), align = _h[0], shift = _h[1];
                        adaptor.setAttribute(parents[i], 'align', align);
                        if (shift) {
                            adaptor.setStyle(parents[i], 'position', 'relative');
                            adaptor.setStyle(parents[i], 'left', this.em(shift));
                        }
                        if (i < n && this.jax.math.display) {
                            adaptor.setStyle(parents[i], 'margin-bottom', this.em(bbox.lineLeading));
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_a = _e.return)) _a.call(_e);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            };
            ChtmlMrow.prototype.handleVerticalAlign = function (dom) {
                if (this.dh) {
                    this.adaptor.setStyle(this.adaptor.parent(dom), 'vertical-align', this.em(this.dh));
                }
            };
            ChtmlMrow.prototype.handleNegativeWidth = function (dom) {
                var w = this.getBBox().w;
                if (w < 0) {
                    this.adaptor.setStyle(dom, 'width', this.em(Math.max(0, w)));
                    this.adaptor.setStyle(dom, 'marginRight', this.em(w));
                }
            };
            ChtmlMrow.prototype.createChtmlNodes = function (parents) {
                var n = this.linebreakCount;
                if (!n)
                    return _super.prototype.createChtmlNodes.call(this, parents);
                var adaptor = this.adaptor;
                var kind = (this.node.isInferred ? 'mjx-linestack' : 'mjx-' + this.node.kind);
                this.dom = [adaptor.append(parents[0], this.html(kind))];
                if (kind === 'mjx-mrow' && !this.isStack) {
                    adaptor.setAttribute(this.dom[0], 'break-top', 'true');
                }
                if (this.node.getProperty('process-breaks')) {
                    adaptor.setAttribute(this.dom[0], 'breakable', 'true');
                }
                if (this.node.isInferred || !this.isStack) {
                    var valign = this.parent.node.attributes.get('data-vertical-align');
                    if (valign === 'middle' || valign === 'center' || valign === 'bottom') {
                        adaptor.setAttribute(this.dom[0], 'break-align', valign);
                    }
                }
                this.dom = [adaptor.append(this.handleHref(parents)[0], this.dom[0])];
                var chtml = Array(n);
                for (var i = 0; i <= n; i++) {
                    chtml[i] = adaptor.append(this.dom[0], this.html('mjx-linebox', { 'lineno': i }));
                }
                return chtml;
            };
            ChtmlMrow.prototype.addChildren = function (parents) {
                var e_2, _a;
                var i = 0;
                try {
                    for (var _b = __values(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var child = _c.value;
                        var n = child.breakCount;
                        child.toCHTML(parents.slice(i, i + n + 1));
                        i += n;
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            };
            return ChtmlMrow;
        }(Base)),
        _a.kind = mrow_js_3.MmlMrow.prototype.kind,
        _a.styles = {
            'mjx-linestack, mjx-mrow[break-top]': {
                display: 'inline-table',
                width: '100%'
            },
            'mjx-linestack[break-align="bottom"], mjx-mrow[break-top][break-align="bottom"]': {
                display: 'inline-block'
            },
            'mjx-linestack[break-align="middle"], mjx-mrow[break-top][break-align="middle"]': {
                'vertical-align': 'middle'
            },
            'mjx-linestack[break-align="center"], mjx-mrow[break-top][break-align="center"]': {
                'vertical-align': 'middle'
            },
            'mjx-linestack[breakable]': {
                display: 'inline'
            },
            'mjx-linestack[breakable] > mjx-linebox': {
                display: 'inline'
            },
            'mjx-linestack[breakable] > mjx-linebox::before': {
                'white-space': 'pre',
                content: '"\\A"'
            },
            'mjx-linestack[breakable] > mjx-linebox::after': {
                'white-space': 'normal',
                content: '" "',
                'letter-spacing': '-.999em',
                'font-family': 'MJX-BRK'
            },
            'mjx-linestack[breakable] > mjx-linebox:first-of-type::before': {
                display: 'none'
            },
            'mjx-linestack[breakable] > mjx-linebox:last-of-type::after': {
                display: 'none'
            },
            'mjx-linebox': {
                display: 'block'
            },
            'mjx-linebox[align="left"]': {
                'text-align': 'left'
            },
            'mjx-linebox[align="center"]': {
                'text-align': 'center'
            },
            'mjx-linebox[align="right"]': {
                'text-align': 'right'
            },
            'mjx-linestrut': {
                display: 'inline-block',
                height: '1em',
                'vertical-align': '-.25em'
            }
        },
        _a;
})();
exports.ChtmlInferredMrow = (function () {
    var _a;
    var Base = (0, mrow_js_2.CommonInferredMrowMixin)(exports.ChtmlMrow);
    return _a = (function (_super) {
            __extends(ChtmlInferredMrow, _super);
            function ChtmlInferredMrow() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            return ChtmlInferredMrow;
        }(Base)),
        _a.kind = mrow_js_3.MmlInferredMrow.prototype.kind,
        _a;
})();
//# sourceMappingURL=mrow.js.map