"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FontData = exports.mergeOptions = exports.NOSTRETCH = void 0;
var Options_js_1 = require("../../util/Options.js");
var AsyncLoad_js_1 = require("../../util/AsyncLoad.js");
var Retries_js_1 = require("../../util/Retries.js");
var mathjax_js_1 = require("../../mathjax.js");
exports.NOSTRETCH = { dir: 0 };
;
function mergeOptions(dst, src) {
    return (src ? (0, Options_js_1.defaultOptions)([dst], [src])[0] : dst);
}
exports.mergeOptions = mergeOptions;
var FontData = exports.FontData = (function () {
    function FontData(options) {
        if (options === void 0) { options = null; }
        var _this = this;
        this.variant = {};
        this.delimiters = {};
        this.cssFontMap = {};
        this.cssFontPrefix = '';
        this.remapChars = {};
        this.skewIcFactor = .75;
        var CLASS = this.CLASS;
        this.options = (0, Options_js_1.userOptions)((0, Options_js_1.defaultOptions)({}, CLASS.OPTIONS), options);
        this.params = __assign({}, CLASS.defaultParams);
        this.sizeVariants = __spreadArray([], __read(CLASS.defaultSizeVariants), false);
        this.stretchVariants = __spreadArray([], __read(CLASS.defaultStretchVariants), false);
        this.defineCssFonts(CLASS.defaultCssFonts);
        this.cssFamilyPrefix = CLASS.defaultCssFamilyPrefix;
        this.createVariants(CLASS.defaultVariants);
        this.defineDelimiters(CLASS.defaultDelimiters);
        Object.keys(CLASS.defaultChars).forEach(function (name) { return _this.defineChars(name, CLASS.defaultChars[name]); });
        this.defineRemap('accent', CLASS.defaultAccentMap);
        this.defineRemap('mo', CLASS.defaultMoMap);
        this.defineRemap('mn', CLASS.defaultMnMap);
        this.defineDynamicCharacters(CLASS.dynamicFiles);
        CLASS.dynamicExtensions.forEach(function (data) { return _this.defineDynamicCharacters(data.files); });
    }
    Object.defineProperty(FontData.prototype, "CLASS", {
        get: function () {
            return this.constructor;
        },
        enumerable: false,
        configurable: true
    });
    FontData.charOptions = function (font, n) {
        var char = font[n];
        if (!Array.isArray(char)) {
            throw Error("Character data hasn't been loaded for 0x".concat(n.toString(16).toUpperCase()));
        }
        if (char.length === 3) {
            char[3] = {};
        }
        return char[3];
    };
    FontData.defineDynamicFiles = function (dynamicFiles, extension) {
        if (extension === void 0) { extension = ''; }
        var list = {};
        (dynamicFiles || []).forEach(function (_a) {
            var _b = __read(_a, 3), file = _b[0], variants = _b[1], delimiters = _b[2];
            list[file] = {
                extension: extension,
                file: file,
                variants: variants,
                delimiters: delimiters || [],
                promise: null, failed: false, setup: (function (_font) { list[file].failed = true; })
            };
        });
        return list;
    };
    FontData.dynamicSetup = function (extension, file, variants, delimiters, fonts) {
        var _this = this;
        if (delimiters === void 0) { delimiters = {}; }
        if (fonts === void 0) { fonts = null; }
        var data = (extension ? this.dynamicExtensions.get(extension) : null);
        var files = (extension ? data.files : this.dynamicFiles);
        files[file].setup = function (font) {
            Object.keys(variants).forEach(function (name) { return font.defineChars(name, variants[name]); });
            font.defineDelimiters(delimiters);
            extension && _this.adjustDelimiters(font.delimiters, Object.keys(delimiters), data.sizeN, data.stretchN);
            fonts && font.addDynamicFontCss(fonts);
        };
    };
    FontData.adjustDelimiters = function (delimiters, keys, sizeN, stretchN) {
        var _this = this;
        keys.forEach(function (id) {
            var delim = delimiters[parseInt(id)];
            if ('dir' in delim) {
                if (delim.variants) {
                    delim.variants = _this.adjustArrayIndices(delim.variants, sizeN);
                }
                if (delim.stretchv) {
                    delim.stretchv = _this.adjustArrayIndices(delim.stretchv, stretchN);
                }
            }
        });
    };
    FontData.adjustArrayIndices = function (list, N) {
        return list.map(function (n) { return (n < 0 ? N - 1 - n : n); });
    };
    FontData.addExtension = function (data, prefix) {
        var e_1, _a;
        if (prefix === void 0) { prefix = ''; }
        var extension = {
            name: data.name,
            prefix: prefix,
            files: this.defineDynamicFiles(data.ranges, data.name),
            sizeN: this.defaultSizeVariants.length,
            stretchN: this.defaultStretchVariants.length
        };
        this.dynamicExtensions.set(data.name, extension);
        try {
            for (var _b = __values([
                ['options', 'OPTIONS'],
                ['variants', 'defaultVariants'],
                ['cssFonts', 'defaultCssFonts'],
                ['accentMap', 'defaultAccentMap'],
                ['moMap', 'defaultMoMap'],
                ['mnMap', 'defaultMnMap'],
                ['parameters', 'defaultParams'],
                ['chars', 'defaultChars'],
                ['sizeVariants', 'defaultSizeVariants'],
                ['stretchVariants', 'defaultStretchVariants']
            ]), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), src = _d[0], dst = _d[1];
                mergeOptions(this[dst], data[src]);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (data.delimiters) {
            Object.assign(this.defaultDelimiters, data.delimiters);
            this.adjustDelimiters(this.defaultDelimiters, Object.keys(data.delimiters), extension.sizeN, extension.stretchN);
        }
    };
    FontData.prototype.setOptions = function (options) {
        mergeOptions(this.options, options);
    };
    FontData.prototype.addExtension = function (data, prefix) {
        var e_2, _a;
        if (prefix === void 0) { prefix = ''; }
        var dynamicFont = {
            name: data.name,
            prefix: prefix,
            files: this.CLASS.defineDynamicFiles(data.ranges, prefix),
            sizeN: this.sizeVariants.length,
            stretchN: this.stretchVariants.length
        };
        this.CLASS.dynamicExtensions.set(data.name, dynamicFont);
        (0, Options_js_1.defaultOptions)(this.options, data.options || {});
        (0, Options_js_1.defaultOptions)(this.params, data.parameters || {});
        this.sizeVariants = mergeOptions(this.sizeVariants, data.sizeVariants);
        this.stretchVariants = mergeOptions(this.stretchVariants, data.stretchVariants);
        this.defineCssFonts(mergeOptions([], data.cssFonts));
        this.createVariants(mergeOptions([], data.variants));
        if (data.delimiters) {
            this.defineDelimiters(mergeOptions([], data.delimiters));
            this.CLASS.adjustDelimiters(this.delimiters, Object.keys(data.delimiters), dynamicFont.sizeN, dynamicFont.stretchN);
        }
        try {
            for (var _b = __values(Object.keys(data.chars || {})), _c = _b.next(); !_c.done; _c = _b.next()) {
                var name_1 = _c.value;
                this.defineChars(name_1, data.chars[name_1]);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        this.defineRemap('accent', data.accentMap);
        this.defineRemap('mo', data.moMap);
        this.defineRemap('mn', data.mnMap);
        if (data.ranges) {
            this.defineDynamicCharacters(dynamicFont.files);
        }
    };
    Object.defineProperty(FontData.prototype, "styles", {
        get: function () {
            return this._styles;
        },
        set: function (style) {
            this._styles = style;
        },
        enumerable: false,
        configurable: true
    });
    FontData.prototype.createVariant = function (name, inherit, link) {
        if (inherit === void 0) { inherit = null; }
        if (link === void 0) { link = null; }
        var variant = {
            linked: [],
            chars: Object.create(inherit ? this.variant[inherit].chars : {})
        };
        if (this.variant[link]) {
            Object.assign(variant.chars, this.variant[link].chars);
            this.variant[link].linked.push(variant.chars);
            variant.chars = Object.create(variant.chars);
        }
        this.remapSmpChars(variant.chars, name);
        this.variant[name] = variant;
    };
    FontData.prototype.remapSmpChars = function (chars, name) {
        var e_3, _a, e_4, _b;
        var CLASS = this.CLASS;
        if (CLASS.VariantSmp[name]) {
            var SmpRemap = CLASS.SmpRemap;
            var SmpGreek = [null, null, CLASS.SmpRemapGreekU, CLASS.SmpRemapGreekL];
            try {
                for (var _c = __values(CLASS.SmpRanges), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var _e = __read(_d.value, 3), i = _e[0], lo = _e[1], hi = _e[2];
                    var base = CLASS.VariantSmp[name][i];
                    if (!base)
                        continue;
                    for (var n = lo; n <= hi; n++) {
                        if (n === 0x3A2)
                            continue;
                        var smp = base + n - lo;
                        chars[n] = this.smpChar(SmpRemap[smp] || smp);
                    }
                    if (SmpGreek[i]) {
                        try {
                            for (var _f = (e_4 = void 0, __values(Object.keys(SmpGreek[i]).map(function (x) { return parseInt(x); }))), _g = _f.next(); !_g.done; _g = _f.next()) {
                                var n = _g.value;
                                chars[n] = this.smpChar(base + SmpGreek[i][n]);
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                    }
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
        if (name === 'bold') {
            chars[0x3DC] = this.smpChar(0x1D7CA);
            chars[0x3DD] = this.smpChar(0x1D7CB);
        }
    };
    FontData.prototype.smpChar = function (n) {
        return [, , , { smp: n }];
    };
    FontData.prototype.createVariants = function (variants) {
        var e_5, _a;
        try {
            for (var variants_1 = __values(variants), variants_1_1 = variants_1.next(); !variants_1_1.done; variants_1_1 = variants_1.next()) {
                var variant = variants_1_1.value;
                this.createVariant(variant[0], variant[1], variant[2]);
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (variants_1_1 && !variants_1_1.done && (_a = variants_1.return)) _a.call(variants_1);
            }
            finally { if (e_5) throw e_5.error; }
        }
    };
    FontData.prototype.defineChars = function (name, chars) {
        var e_6, _a;
        var variant = this.variant[name];
        Object.assign(variant.chars, chars);
        try {
            for (var _b = __values(variant.linked), _c = _b.next(); !_c.done; _c = _b.next()) {
                var link = _c.value;
                Object.assign(link, chars);
            }
        }
        catch (e_6_1) { e_6 = { error: e_6_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_6) throw e_6.error; }
        }
    };
    FontData.prototype.defineCssFonts = function (fonts) {
        var e_7, _a;
        Object.assign(this.cssFontMap, fonts);
        try {
            for (var _b = __values(Object.keys(fonts)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var name_2 = _c.value;
                if (this.cssFontMap[name_2][0] === 'unknown') {
                    this.cssFontMap[name_2][0] = this.options.unknownFamily;
                }
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_7) throw e_7.error; }
        }
    };
    FontData.prototype.defineDelimiters = function (delims) {
        Object.assign(this.delimiters, delims);
    };
    FontData.prototype.defineRemap = function (name, remap) {
        if (remap) {
            if (!this.remapChars.hasOwnProperty(name)) {
                this.remapChars[name] = {};
            }
            Object.assign(this.remapChars[name], remap);
        }
    };
    FontData.prototype.defineDynamicCharacters = function (dynamicFiles) {
        var e_8, _a, e_9, _b;
        try {
            for (var _c = __values(Object.keys(dynamicFiles)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var file = _d.value;
                var dynamic = dynamicFiles[file];
                try {
                    for (var _e = (e_9 = void 0, __values(Object.keys(dynamic.variants))), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var name_3 = _f.value;
                        this.defineChars(name_3, this.flattenRanges(dynamic.variants[name_3], dynamic));
                    }
                }
                catch (e_9_1) { e_9 = { error: e_9_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                    }
                    finally { if (e_9) throw e_9.error; }
                }
                this.defineDelimiters(this.flattenRanges(dynamic.delimiters, dynamic));
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_8) throw e_8.error; }
        }
    };
    FontData.prototype.flattenRanges = function (ranges, dynamic) {
        var e_10, _a;
        var chars = {};
        try {
            for (var ranges_1 = __values(ranges), ranges_1_1 = ranges_1.next(); !ranges_1_1.done; ranges_1_1 = ranges_1.next()) {
                var n = ranges_1_1.value;
                if (Array.isArray(n)) {
                    for (var j = n[0]; j <= n[1]; j++) {
                        chars[j] = dynamic;
                    }
                }
                else {
                    chars[n] = dynamic;
                }
            }
        }
        catch (e_10_1) { e_10 = { error: e_10_1 }; }
        finally {
            try {
                if (ranges_1_1 && !ranges_1_1.done && (_a = ranges_1.return)) _a.call(ranges_1);
            }
            finally { if (e_10) throw e_10.error; }
        }
        return chars;
    };
    FontData.prototype.dynamicFileName = function (dynamic) {
        var prefix = (!dynamic.extension ? this.options.dynamicPrefix :
            this.CLASS.dynamicExtensions.get(dynamic.extension).prefix);
        return (dynamic.file.match(/^(?:[\/\[]|[a-z]+:\/\/|[a-z]:)/i) ? dynamic.file :
            prefix + '/' + dynamic.file.replace(/\.js$/, ''));
    };
    FontData.prototype.loadDynamicFile = function (dynamic) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                if (dynamic.failed)
                    return [2, Promise.reject(new Error("dynamic file '".concat(dynamic.file, "' failed to load")))];
                if (!dynamic.promise) {
                    dynamic.promise = (0, AsyncLoad_js_1.asyncLoad)(this.dynamicFileName(dynamic)).catch(function (err) {
                        dynamic.failed = true;
                        console.warn(err);
                    });
                }
                return [2, dynamic.promise.then(function () { return dynamic.setup(_this); })];
            });
        });
    };
    FontData.prototype.loadDynamicFiles = function () {
        var e_11, _a;
        var _this = this;
        var dynamicFiles = this.CLASS.dynamicFiles;
        var promises = Object.keys(dynamicFiles).map(function (name) { return _this.loadDynamicFile(dynamicFiles[name]); });
        var _loop_1 = function (data) {
            promises.push.apply(promises, __spreadArray([], __read(Object.keys(data.files).map(function (name) { return _this.loadDynamicFile(data.files[name]); })), false));
        };
        try {
            for (var _b = __values(this.CLASS.dynamicExtensions.values()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var data = _c.value;
                _loop_1(data);
            }
        }
        catch (e_11_1) { e_11 = { error: e_11_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_11) throw e_11.error; }
        }
        return Promise.all(promises);
    };
    FontData.prototype.loadDynamicFilesSync = function () {
        var e_12, _a;
        var _this = this;
        if (!mathjax_js_1.mathjax.asyncLoad) {
            throw Error('MathJax(loadDynamicFilesSync): mathjax.asyncLoad must be specified and synchronous');
        }
        var dynamicFiles = this.CLASS.dynamicFiles;
        Object.keys(dynamicFiles).forEach(function (name) { return _this.loadDynamicFileSync(dynamicFiles[name]); });
        var _loop_2 = function (data) {
            Object.keys(data.files).forEach(function (name) { return _this.loadDynamicFileSync(data.files[name]); });
        };
        try {
            for (var _b = __values(this.CLASS.dynamicExtensions.values()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var data = _c.value;
                _loop_2(data);
            }
        }
        catch (e_12_1) { e_12 = { error: e_12_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_12) throw e_12.error; }
        }
    };
    FontData.prototype.loadDynamicFileSync = function (dynamic) {
        if (!dynamic.promise) {
            dynamic.promise = Promise.resolve();
            try {
                mathjax_js_1.mathjax.asyncLoad(this.dynamicFileName(dynamic));
            }
            catch (err) {
                dynamic.failed = true;
                console.warn(err);
            }
            dynamic.setup(this);
        }
    };
    FontData.prototype.addDynamicFontCss = function (_fonts, _root) {
    };
    FontData.prototype.getDelimiter = function (n) {
        var delim = this.delimiters[n];
        if (delim && !('dir' in delim)) {
            this.delimiters[n] = null;
            (0, Retries_js_1.retryAfter)(this.loadDynamicFile(delim));
            return null;
        }
        return delim;
    };
    FontData.prototype.getSizeVariant = function (n, i) {
        var delim = this.getDelimiter(n);
        if (delim && delim.variants) {
            i = delim.variants[i];
        }
        return this.sizeVariants[i];
    };
    FontData.prototype.getStretchVariant = function (n, i) {
        var delim = this.getDelimiter(n);
        return this.stretchVariants[delim.stretchv ? delim.stretchv[i] : 0];
    };
    FontData.prototype.getStretchVariants = function (n) {
        var _this = this;
        return [0, 1, 2, 3].map(function (i) { return _this.getStretchVariant(n, i); });
    };
    FontData.prototype.getChar = function (name, n) {
        var char = this.variant[name].chars[n];
        if (char && !Array.isArray(char)) {
            var variant = this.variant[name];
            delete variant.chars[n];
            variant.linked.forEach(function (link) { return delete link[n]; });
            (0, Retries_js_1.retryAfter)(this.loadDynamicFile(char));
            return null;
        }
        return char;
    };
    FontData.prototype.getVariant = function (name) {
        return this.variant[name];
    };
    FontData.prototype.getCssFont = function (variant) {
        return this.cssFontMap[variant] || ['serif', false, false];
    };
    FontData.prototype.getFamily = function (family) {
        return (this.cssFamilyPrefix ? this.cssFamilyPrefix + ', ' + family : family);
    };
    FontData.prototype.getRemappedChar = function (name, c) {
        var map = this.remapChars[name] || {};
        return map[c];
    };
    FontData.OPTIONS = {
        unknownFamily: 'serif',
        dynamicPrefix: '.'
    };
    FontData.JAX = 'common';
    FontData.NAME = '';
    FontData.defaultVariants = [
        ['normal'],
        ['bold', 'normal'],
        ['italic', 'normal'],
        ['bold-italic', 'italic', 'bold'],
        ['double-struck', 'bold'],
        ['fraktur', 'normal'],
        ['bold-fraktur', 'bold', 'fraktur'],
        ['script', 'italic'],
        ['bold-script', 'bold-italic', 'script'],
        ['sans-serif', 'normal'],
        ['bold-sans-serif', 'bold', 'sans-serif'],
        ['sans-serif-italic', 'italic', 'sans-serif'],
        ['sans-serif-bold-italic', 'bold-italic', 'bold-sans-serif'],
        ['monospace', 'normal'],
        ['-smallop', 'normal'],
        ['-largeop', 'normal'],
        ['-tex-calligraphic', 'italic'],
        ['-tex-bold-calligraphic', 'bold-italic'],
        ['-tex-oldstyle', 'normal'],
        ['-tex-bold-oldstyle', 'bold'],
        ['-tex-mathit', 'italic'],
        ['-tex-variant', 'normal']
    ];
    FontData.defaultCssFonts = {
        normal: ['unknown', false, false],
        bold: ['unknown', false, true],
        italic: ['unknown', true, false],
        'bold-italic': ['unknown', true, true],
        'double-struck': ['unknown', false, true],
        fraktur: ['unknown', false, false],
        'bold-fraktur': ['unknown', false, true],
        script: ['cursive', false, false],
        'bold-script': ['cursive', false, true],
        'sans-serif': ['sans-serif', false, false],
        'bold-sans-serif': ['sans-serif', false, true],
        'sans-serif-italic': ['sans-serif', true, false],
        'sans-serif-bold-italic': ['sans-serif', true, true],
        monospace: ['monospace', false, false],
        '-smallop': ['unknown', false, false],
        '-largeop': ['unknown', false, false],
        '-tex-calligraphic': ['cursive', true, false],
        '-tex-bold-calligraphic': ['cursive', true, true],
        '-tex-oldstyle': ['unknown', false, false],
        '-tex-bold-oldstyle': ['unknown', false, true],
        '-tex-mathit': ['unknown', true, false],
        '-tex-variant': ['unknown', false, false]
    };
    FontData.defaultCssFamilyPrefix = '';
    FontData.VariantSmp = {
        bold: [0x1D400, 0x1D41A, 0x1D6A8, 0x1D6C2, 0x1D7CE],
        italic: [0x1D434, 0x1D44E, 0x1D6E2, 0x1D6FC],
        'bold-italic': [0x1D468, 0x1D482, 0x1D71C, 0x1D736],
        script: [0x1D49C, 0x1D4B6],
        'bold-script': [0x1D4D0, 0x1D4EA],
        fraktur: [0x1D504, 0x1D51E],
        'double-struck': [0x1D538, 0x1D552, , , 0x1D7D8],
        'bold-fraktur': [0x1D56C, 0x1D586],
        'sans-serif': [0x1D5A0, 0x1D5BA, , , 0x1D7E2],
        'bold-sans-serif': [0x1D5D4, 0x1D5EE, 0x1D756, 0x1D770, 0x1D7EC],
        'sans-serif-italic': [0x1D608, 0x1D622],
        'sans-serif-bold-italic': [0x1D63C, 0x1D656, 0x1D790, 0x1D7AA],
        'monospace': [0x1D670, 0x1D68A, , , 0x1D7F6]
    };
    FontData.SmpRanges = [
        [0, 0x41, 0x5A],
        [1, 0x61, 0x7A],
        [2, 0x391, 0x3A9],
        [3, 0x3B1, 0x3C9],
        [4, 0x30, 0x39]
    ];
    FontData.SmpRemap = {
        0x1D455: 0x210E,
        0x1D49D: 0x212C,
        0x1D4A0: 0x2130,
        0x1D4A1: 0x2131,
        0x1D4A3: 0x210B,
        0x1D4A4: 0x2110,
        0x1D4A7: 0x2112,
        0x1D4A8: 0x2133,
        0x1D4AD: 0x211B,
        0x1D4BA: 0x212F,
        0x1D4BC: 0x210A,
        0x1D4C4: 0x2134,
        0x1D506: 0x212D,
        0x1D50B: 0x210C,
        0x1D50C: 0x2111,
        0x1D515: 0x211C,
        0x1D51D: 0x2128,
        0x1D53A: 0x2102,
        0x1D53F: 0x210D,
        0x1D545: 0x2115,
        0x1D547: 0x2119,
        0x1D548: 0x211A,
        0x1D549: 0x211D,
        0x1D551: 0x2124,
    };
    FontData.SmpRemapGreekU = {
        0x2207: 0x19,
        0x03F4: 0x11
    };
    FontData.SmpRemapGreekL = {
        0x3D1: 0x1B,
        0x3D5: 0x1D,
        0x3D6: 0x1F,
        0x3F0: 0x1C,
        0x3F1: 0x1E,
        0x3F5: 0x1A,
        0x2202: 0x19
    };
    FontData.defaultAccentMap = {
        0x005E: '\u02C6',
        0x007E: '\u02DC',
        0x0300: '\u02CB',
        0x0301: '\u02CA',
        0x0302: '\u02C6',
        0x0303: '\u02DC',
        0x0304: '\u02C9',
        0x0306: '\u02D8',
        0x0307: '\u02D9',
        0x0308: '\u00A8',
        0x030A: '\u02DA',
        0x030C: '\u02C7',
        0x2192: '\u20D7'
    };
    FontData.defaultMoMap = {
        0x002D: '\u2212'
    };
    FontData.defaultMnMap = {
        0x002D: '\u2212'
    };
    FontData.defaultParams = {
        x_height: .442,
        quad: 1,
        num1: .676,
        num2: .394,
        num3: .444,
        denom1: .686,
        denom2: .345,
        sup1: .413,
        sup2: .363,
        sup3: .289,
        sub1: .15,
        sub2: .247,
        sup_drop: .386,
        sub_drop: .05,
        delim1: 2.39,
        delim2: 1.0,
        axis_height: .25,
        rule_thickness: .06,
        big_op_spacing1: .111,
        big_op_spacing2: .167,
        big_op_spacing3: .2,
        big_op_spacing4: .6,
        big_op_spacing5: .1,
        surd_height: .06,
        scriptspace: .05,
        nulldelimiterspace: .12,
        delimiterfactor: 901,
        delimitershortfall: .3,
        rule_factor: 1.25,
        min_rule_thickness: 1.25,
        separation_factor: 1.75,
        extra_ic: .033,
        extender_factor: .333
    };
    FontData.defaultDelimiters = {};
    FontData.defaultChars = {};
    FontData.defaultSizeVariants = [];
    FontData.defaultStretchVariants = [];
    FontData.dynamicFiles = {};
    FontData.dynamicExtensions = new Map();
    return FontData;
}());
//# sourceMappingURL=FontData.js.map