import { CommonOutputJax, UnknownBBox } from './common.js';
import { OptionList } from '../util/Options.js';
import { MathDocument } from '../core/MathDocument.js';
import { MathItem } from '../core/MathItem.js';
import { SvgWrapper, SvgWrapperClass } from './svg/Wrapper.js';
import { SvgWrapperFactory } from './svg/WrapperFactory.js';
import { SvgCharOptions, SvgVariantData, SvgDelimiterData, SvgFontData, SvgFontDataClass } from './svg/FontData.js';
import { StyleList as CssStyleList } from '../util/StyleList.js';
import { FontCache } from './svg/FontCache.js';
export declare const SVGNS = "http://www.w3.org/2000/svg";
export declare const XLINKNS = "http://www.w3.org/1999/xlink";
export declare class SVG<N, T, D> extends CommonOutputJax<N, T, D, SvgWrapper<N, T, D>, SvgWrapperFactory<N, T, D>, SvgWrapperClass<N, T, D>, SvgCharOptions, SvgVariantData, SvgDelimiterData, SvgFontData, SvgFontDataClass> {
    static NAME: string;
    static OPTIONS: OptionList;
    static commonStyles: CssStyleList;
    static FONTCACHEID: string;
    static STYLESHEETID: string;
    get forceInlineBreaks(): boolean;
    fontCache: FontCache<N, T, D>;
    minwidth: number;
    shift: number;
    svgStyles: N;
    constructor(options?: OptionList);
    initialize(): void;
    clearFontCache(): void;
    reset(): void;
    escaped(math: MathItem<N, T, D>, html: MathDocument<N, T, D>): N;
    styleSheet(html: MathDocument<N, T, D>): N;
    pageElements(html: MathDocument<N, T, D>): N;
    protected findCache(html: MathDocument<N, T, D>): boolean;
    processMath(wrapper: SvgWrapper<N, T, D>, parent: N): void;
    protected createRoot(wrapper: SvgWrapper<N, T, D>): [N, N];
    protected createSVG(h: number, d: number, w: number): [N, N];
    protected typesetSvg(wrapper: SvgWrapper<N, T, D>, svg: N, g: N): void;
    protected setIndent(svg: N, align: string, shift: number): void;
    protected handleInlineBreaks(wrapper: SvgWrapper<N, T, D>, svg: N, g: N): void;
    protected addInlineBreak(nsvg: N, dimen: number, forced: boolean): void;
    ex(m: number): string;
    svg(kind: string, properties?: OptionList, children?: (N | T)[]): N;
    unknownText(text: string, variant: string): N;
    measureTextNode(text: N): UnknownBBox;
}
