"use strict";
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.SvgWrappers = void 0;
var Wrapper_js_1 = require("./Wrapper.js");
var math_js_1 = require("./Wrappers/math.js");
var mrow_js_1 = require("./Wrappers/mrow.js");
var mi_js_1 = require("./Wrappers/mi.js");
var mo_js_1 = require("./Wrappers/mo.js");
var mn_js_1 = require("./Wrappers/mn.js");
var ms_js_1 = require("./Wrappers/ms.js");
var mtext_js_1 = require("./Wrappers/mtext.js");
var merror_js_1 = require("./Wrappers/merror.js");
var mspace_js_1 = require("./Wrappers/mspace.js");
var mpadded_js_1 = require("./Wrappers/mpadded.js");
var mphantom_js_1 = require("./Wrappers/mphantom.js");
var mfrac_js_1 = require("./Wrappers/mfrac.js");
var msqrt_js_1 = require("./Wrappers/msqrt.js");
var mroot_js_1 = require("./Wrappers/mroot.js");
var mfenced_js_1 = require("./Wrappers/mfenced.js");
var msubsup_js_1 = require("./Wrappers/msubsup.js");
var munderover_js_1 = require("./Wrappers/munderover.js");
var mmultiscripts_js_1 = require("./Wrappers/mmultiscripts.js");
var mtable_js_1 = require("./Wrappers/mtable.js");
var mtr_js_1 = require("./Wrappers/mtr.js");
var mtd_js_1 = require("./Wrappers/mtd.js");
var maction_js_1 = require("./Wrappers/maction.js");
var menclose_js_1 = require("./Wrappers/menclose.js");
var semantics_js_1 = require("./Wrappers/semantics.js");
var mglyph_js_1 = require("./Wrappers/mglyph.js");
var TeXAtom_js_1 = require("./Wrappers/TeXAtom.js");
var TextNode_js_1 = require("./Wrappers/TextNode.js");
var HtmlNode_js_1 = require("./Wrappers/HtmlNode.js");
exports.SvgWrappers = (_a = {},
    _a[math_js_1.SvgMath.kind] = math_js_1.SvgMath,
    _a[mrow_js_1.SvgMrow.kind] = mrow_js_1.SvgMrow,
    _a[mrow_js_1.SvgInferredMrow.kind] = mrow_js_1.SvgInferredMrow,
    _a[mi_js_1.SvgMi.kind] = mi_js_1.SvgMi,
    _a[mo_js_1.SvgMo.kind] = mo_js_1.SvgMo,
    _a[mn_js_1.SvgMn.kind] = mn_js_1.SvgMn,
    _a[ms_js_1.SvgMs.kind] = ms_js_1.SvgMs,
    _a[mtext_js_1.SvgMtext.kind] = mtext_js_1.SvgMtext,
    _a[merror_js_1.SvgMerror.kind] = merror_js_1.SvgMerror,
    _a[mspace_js_1.SvgMspace.kind] = mspace_js_1.SvgMspace,
    _a[mpadded_js_1.SvgMpadded.kind] = mpadded_js_1.SvgMpadded,
    _a[mphantom_js_1.SvgMphantom.kind] = mphantom_js_1.SvgMphantom,
    _a[mfrac_js_1.SvgMfrac.kind] = mfrac_js_1.SvgMfrac,
    _a[msqrt_js_1.SvgMsqrt.kind] = msqrt_js_1.SvgMsqrt,
    _a[mroot_js_1.SvgMroot.kind] = mroot_js_1.SvgMroot,
    _a[mfenced_js_1.SvgMfenced.kind] = mfenced_js_1.SvgMfenced,
    _a[msubsup_js_1.SvgMsub.kind] = msubsup_js_1.SvgMsub,
    _a[msubsup_js_1.SvgMsup.kind] = msubsup_js_1.SvgMsup,
    _a[msubsup_js_1.SvgMsubsup.kind] = msubsup_js_1.SvgMsubsup,
    _a[munderover_js_1.SvgMunder.kind] = munderover_js_1.SvgMunder,
    _a[munderover_js_1.SvgMover.kind] = munderover_js_1.SvgMover,
    _a[munderover_js_1.SvgMunderover.kind] = munderover_js_1.SvgMunderover,
    _a[mmultiscripts_js_1.SvgMmultiscripts.kind] = mmultiscripts_js_1.SvgMmultiscripts,
    _a[mtable_js_1.SvgMtable.kind] = mtable_js_1.SvgMtable,
    _a[mtr_js_1.SvgMtr.kind] = mtr_js_1.SvgMtr,
    _a[mtr_js_1.SvgMlabeledtr.kind] = mtr_js_1.SvgMlabeledtr,
    _a[mtd_js_1.SvgMtd.kind] = mtd_js_1.SvgMtd,
    _a[maction_js_1.SvgMaction.kind] = maction_js_1.SvgMaction,
    _a[menclose_js_1.SvgMenclose.kind] = menclose_js_1.SvgMenclose,
    _a[semantics_js_1.SvgSemantics.kind] = semantics_js_1.SvgSemantics,
    _a[semantics_js_1.SvgAnnotation.kind] = semantics_js_1.SvgAnnotation,
    _a[semantics_js_1.SvgAnnotationXML.kind] = semantics_js_1.SvgAnnotationXML,
    _a[semantics_js_1.SvgXmlNode.kind] = semantics_js_1.SvgXmlNode,
    _a[mglyph_js_1.SvgMglyph.kind] = mglyph_js_1.SvgMglyph,
    _a[TeXAtom_js_1.SvgTeXAtom.kind] = TeXAtom_js_1.SvgTeXAtom,
    _a[TextNode_js_1.SvgTextNode.kind] = TextNode_js_1.SvgTextNode,
    _a[HtmlNode_js_1.SvgHtmlNode.kind] = HtmlNode_js_1.SvgHtmlNode,
    _a[Wrapper_js_1.SvgWrapper.kind] = Wrapper_js_1.SvgWrapper,
    _a);
//# sourceMappingURL=Wrappers.js.map