import { SVG } from '../../svg.js';
import { SvgWrapper, SvgWrapperClass } from '../Wrapper.js';
import { SvgWrapperFactory } from '../WrapperFactory.js';
import { SvgCharOptions, SvgVariantData, SvgDelimiterData, SvgFontData, SvgFontDataClass } from '../FontData.js';
import { CommonTextNode, CommonTextNodeClass } from '../../common/Wrappers/TextNode.js';
import { MmlNode } from '../../../core/MmlTree/MmlNode.js';
export interface SvgTextNodeNTD<N, T, D> extends SvgWrapper<N, T, D>, CommonTextNode<N, T, D, SVG<N, T, D>, SvgWrapper<N, T, D>, SvgWrapperFactory<N, T, D>, SvgWrapperClass<N, T, D>, SvgCharOptions, SvgVariantData, SvgDelimiterData, SvgFontData, SvgFontDataClass> {
}
export interface SvgTextNodeClass<N, T, D> extends SvgWrapperClass<N, T, D>, CommonTextNodeClass<N, T, D, SVG<N, T, D>, SvgWrapper<N, T, D>, SvgWrapperFactory<N, T, D>, SvgWrapperClass<N, T, D>, SvgCharOptions, SvgVariantData, SvgDelimiterData, SvgFontData, SvgFontDataClass> {
    new (factory: SvgWrapperFactory<N, T, D>, node: MmlNode, parent?: SvgWrapper<N, T, D>): SvgTextNodeNTD<N, T, D>;
}
export declare const SvgTextNode: SvgTextNodeClass<any, any, any>;
