"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.annotation = exports.copyAnnotations = exports.showAnnotations = void 0;
var MenuUtil = __importStar(require("./MenuUtil.js"));
function showAnnotations(box, types, cache) {
    return function (menu, sub) {
        getAnnotation(getSemanticNode(menu), types, cache);
        box.attachMenu(menu);
        return createAnnotationMenu(menu, sub, cache, function () { return box.post(); });
    };
}
exports.showAnnotations = showAnnotations;
function copyAnnotations(cache) {
    return function (menu, sub) {
        var annotations = cache.slice();
        cache.length = 0;
        return createAnnotationMenu(menu, sub, annotations, function () { return MenuUtil.copyToClipboard(exports.annotation.trim()); });
    };
}
exports.copyAnnotations = copyAnnotations;
function getSemanticNode(menu) {
    var _a;
    var node = (_a = menu.mathItem) === null || _a === void 0 ? void 0 : _a.root;
    while (node && !node.isKind('semantics')) {
        if (node.isToken || node.childNodes.length !== 1)
            return null;
        node = node.childNodes[0];
    }
    return node;
}
function getAnnotation(node, types, annotations) {
    var e_1, _a;
    if (!node)
        return;
    try {
        for (var _b = __values(node.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
            var child = _c.value;
            if (child.isKind('annotation')) {
                var match = annotationMatch(child, types);
                if (match) {
                    var value = child.childNodes.reduce(function (text, chars) { return text + chars.toString(); }, '');
                    annotations.push([match, value]);
                }
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
}
function annotationMatch(child, types) {
    var e_2, _a;
    var encoding = child.attributes.get('encoding');
    try {
        for (var _b = __values(Object.keys(types)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var type = _c.value;
            if (types[type].indexOf(encoding) >= 0) {
                return type;
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return null;
}
exports.annotation = '';
function createAnnotationMenu(menu, submenu, annotations, action) {
    return menu.factory.get('subMenu')(menu.factory, {
        items: annotations.map(function (_a) {
            var _b = __read(_a, 2), type = _b[0], value = _b[1];
            return {
                type: 'command',
                id: type,
                content: type,
                action: function () {
                    exports.annotation = value;
                    action();
                }
            };
        }),
        id: 'annotations'
    }, submenu);
}
//# sourceMappingURL=AnnotationMenu.js.map