"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MJContextMenu = void 0;
var mj_context_menu_js_1 = require("./mj-context-menu.js");
var MJContextMenu = exports.MJContextMenu = (function (_super) {
    __extends(MJContextMenu, _super);
    function MJContextMenu() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mathItem = null;
        _this.errorMsg = '';
        return _this;
    }
    MJContextMenu.prototype.post = function (x, y) {
        if (this.mathItem) {
            if (y !== undefined) {
                this.getOriginalMenu();
                this.getSemanticsMenu();
                this.getSpeechMenu();
                this.getSvgMenu();
                this.getErrorMessage();
                this.dynamicSubmenus();
            }
            _super.prototype.post.call(this, x, y);
        }
    };
    MJContextMenu.prototype.unpost = function () {
        _super.prototype.unpost.call(this);
        this.mathItem = null;
    };
    MJContextMenu.prototype.findID = function () {
        var e_1, _a;
        var names = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            names[_i] = arguments[_i];
        }
        var menu = this;
        var item = null;
        try {
            for (var names_1 = __values(names), names_1_1 = names_1.next(); !names_1_1.done; names_1_1 = names_1.next()) {
                var name_1 = names_1_1.value;
                if (menu) {
                    item = menu.find(name_1);
                    menu = (item instanceof mj_context_menu_js_1.Submenu ? item.submenu : null);
                }
                else {
                    item = null;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (names_1_1 && !names_1_1.done && (_a = names_1.return)) _a.call(names_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return item;
    };
    MJContextMenu.prototype.setJax = function (jax) {
        this.jax = jax;
    };
    MJContextMenu.prototype.getOriginalMenu = function () {
        var input = this.mathItem.inputJax.name;
        var original = this.findID('Show', 'Original');
        original.content = (input === 'MathML' ? 'Original MathML' : input + ' Commands');
        var clipboard = this.findID('Copy', 'Original');
        clipboard.content = original.content;
    };
    MJContextMenu.prototype.getSemanticsMenu = function () {
        var semantics = this.findID('Settings', 'semantics');
        this.mathItem.inputJax.name === 'MathML' ? semantics.disable() : semantics.enable();
    };
    MJContextMenu.prototype.getSpeechMenu = function () {
        var speech = this.mathItem.outputData.speech;
        this.findID('Show', 'Speech')[speech ? 'enable' : 'disable']();
        this.findID('Copy', 'Speech')[speech ? 'enable' : 'disable']();
    };
    MJContextMenu.prototype.getSvgMenu = function () {
        var svg = this.jax.SVG;
        this.findID('Show', 'SVG')[svg ? 'enable' : 'disable']();
        this.findID('Copy', 'SVG')[svg ? 'enable' : 'disable']();
    };
    MJContextMenu.prototype.getErrorMessage = function () {
        var children = this.mathItem.root.childNodes[0].childNodes;
        var disable = true;
        this.errorMsg = '';
        if (children.length === 1 && children[0].isKind('merror')) {
            var attributes = children[0].attributes;
            this.errorMsg = (attributes.get('data-mjx-error') || attributes.get('data-mjx-message') || '');
            disable = !this.errorMsg;
        }
        this.findID('Show', 'Error')[disable ? 'disable' : 'enable']();
        this.findID('Copy', 'Error')[disable ? 'disable' : 'enable']();
    };
    MJContextMenu.prototype.dynamicSubmenus = function () {
        var e_2, _a;
        try {
            for (var _b = __values(MJContextMenu.DynamicSubmenus), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), id = _d[0], method = _d[1];
                var menu = this.find(id);
                if (!menu)
                    continue;
                var sub = method(this, menu);
                menu.submenu = sub;
                if (sub.items.length) {
                    menu.enable();
                }
                else {
                    menu.disable();
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    MJContextMenu.DynamicSubmenus = new Map();
    return MJContextMenu;
}(mj_context_menu_js_1.ContextMenu));
//# sourceMappingURL=MJContextMenu.js.map