const {combineWithMathJax} = require('../../../../cjs/components/global.js')
const {VERSION} = require('../../../../cjs/components/version.js');

const module1 = require('../../../../cjs/adaptors/HTMLAdaptor.js');
const module2 = require('../../../../cjs/adaptors/browserAdaptor.js');
const module3 = require('../../../../cjs/components/global.js');
const module4 = require('../../../../cjs/core/DOMAdaptor.js');
const module5 = require('../../../../cjs/core/FindMath.js');
const module6 = require('../../../../cjs/core/Handler.js');
const module7 = require('../../../../cjs/core/HandlerList.js');
const module8 = require('../../../../cjs/core/InputJax.js');
const module9 = require('../../../../cjs/core/MathDocument.js');
const module10 = require('../../../../cjs/core/MathItem.js');
const module11 = require('../../../../cjs/core/MathList.js');
const module12 = require('../../../../cjs/core/MmlTree/Attributes.js');
const module13 = require('../../../../cjs/core/MmlTree/MML.js');
const module14 = require('../../../../cjs/core/MmlTree/MathMLVisitor.js');
const module15 = require('../../../../cjs/core/MmlTree/MmlFactory.js');
const module16 = require('../../../../cjs/core/MmlTree/MmlNode.js');
const module17 = require('../../../../cjs/core/MmlTree/MmlNodes/HtmlNode.js');
const module18 = require('../../../../cjs/core/MmlTree/MmlNodes/TeXAtom.js');
const module19 = require('../../../../cjs/core/MmlTree/MmlNodes/maction.js');
const module20 = require('../../../../cjs/core/MmlTree/MmlNodes/maligngroup.js');
const module21 = require('../../../../cjs/core/MmlTree/MmlNodes/malignmark.js');
const module22 = require('../../../../cjs/core/MmlTree/MmlNodes/math.js');
const module23 = require('../../../../cjs/core/MmlTree/MmlNodes/mathchoice.js');
const module24 = require('../../../../cjs/core/MmlTree/MmlNodes/menclose.js');
const module25 = require('../../../../cjs/core/MmlTree/MmlNodes/merror.js');
const module26 = require('../../../../cjs/core/MmlTree/MmlNodes/mfenced.js');
const module27 = require('../../../../cjs/core/MmlTree/MmlNodes/mfrac.js');
const module28 = require('../../../../cjs/core/MmlTree/MmlNodes/mglyph.js');
const module29 = require('../../../../cjs/core/MmlTree/MmlNodes/mi.js');
const module30 = require('../../../../cjs/core/MmlTree/MmlNodes/mmultiscripts.js');
const module31 = require('../../../../cjs/core/MmlTree/MmlNodes/mn.js');
const module32 = require('../../../../cjs/core/MmlTree/MmlNodes/mo.js');
const module33 = require('../../../../cjs/core/MmlTree/MmlNodes/mpadded.js');
const module34 = require('../../../../cjs/core/MmlTree/MmlNodes/mphantom.js');
const module35 = require('../../../../cjs/core/MmlTree/MmlNodes/mroot.js');
const module36 = require('../../../../cjs/core/MmlTree/MmlNodes/mrow.js');
const module37 = require('../../../../cjs/core/MmlTree/MmlNodes/ms.js');
const module38 = require('../../../../cjs/core/MmlTree/MmlNodes/mspace.js');
const module39 = require('../../../../cjs/core/MmlTree/MmlNodes/msqrt.js');
const module40 = require('../../../../cjs/core/MmlTree/MmlNodes/mstyle.js');
const module41 = require('../../../../cjs/core/MmlTree/MmlNodes/msubsup.js');
const module42 = require('../../../../cjs/core/MmlTree/MmlNodes/mtable.js');
const module43 = require('../../../../cjs/core/MmlTree/MmlNodes/mtd.js');
const module44 = require('../../../../cjs/core/MmlTree/MmlNodes/mtext.js');
const module45 = require('../../../../cjs/core/MmlTree/MmlNodes/mtr.js');
const module46 = require('../../../../cjs/core/MmlTree/MmlNodes/munderover.js');
const module47 = require('../../../../cjs/core/MmlTree/MmlNodes/semantics.js');
const module48 = require('../../../../cjs/core/MmlTree/MmlVisitor.js');
const module49 = require('../../../../cjs/core/MmlTree/OperatorDictionary.js');
const module50 = require('../../../../cjs/core/MmlTree/SerializedMmlVisitor.js');
const module51 = require('../../../../cjs/core/OutputJax.js');
const module52 = require('../../../../cjs/core/Tree/Factory.js');
const module53 = require('../../../../cjs/core/Tree/Node.js');
const module54 = require('../../../../cjs/core/Tree/NodeFactory.js');
const module55 = require('../../../../cjs/core/Tree/Visitor.js');
const module56 = require('../../../../cjs/core/Tree/Wrapper.js');
const module57 = require('../../../../cjs/core/Tree/WrapperFactory.js');
const module58 = require('../../../../cjs/handlers/html.js');
const module59 = require('../../../../cjs/handlers/html/HTMLDocument.js');
const module60 = require('../../../../cjs/handlers/html/HTMLDomStrings.js');
const module61 = require('../../../../cjs/handlers/html/HTMLHandler.js');
const module62 = require('../../../../cjs/handlers/html/HTMLMathItem.js');
const module63 = require('../../../../cjs/handlers/html/HTMLMathList.js');
const module64 = require('../../../../cjs/mathjax.js');
const module65 = require('../../../../cjs/util/AsyncLoad.js');
const module66 = require('../../../../cjs/util/BBox.js');
const module67 = require('../../../../cjs/util/BitField.js');
const module68 = require('../../../../cjs/util/Entities.js');
const module69 = require('../../../../cjs/util/FunctionList.js');
const module70 = require('../../../../cjs/util/LinkedList.js');
const module71 = require('../../../../cjs/util/Options.js');
const module72 = require('../../../../cjs/util/PrioritizedList.js');
const module73 = require('../../../../cjs/util/Retries.js');
const module74 = require('../../../../cjs/util/StyleList.js');
const module75 = require('../../../../cjs/util/Styles.js');
const module76 = require('../../../../cjs/util/lengths.js');
const module77 = require('../../../../cjs/util/numeric.js');
const module78 = require('../../../../cjs/util/string.js');

if (MathJax.loader) {
  MathJax.loader.checkVersion('core', VERSION, 'core');
}

combineWithMathJax({_: {
  adaptors: {
    HTMLAdaptor: module1,
    browserAdaptor: module2
  },
  components: {
    global: module3
  },
  core: {
    DOMAdaptor: module4,
    FindMath: module5,
    Handler: module6,
    HandlerList: module7,
    InputJax: module8,
    MathDocument: module9,
    MathItem: module10,
    MathList: module11,
    MmlTree: {
      Attributes: module12,
      MML: module13,
      MathMLVisitor: module14,
      MmlFactory: module15,
      MmlNode: module16,
      MmlNodes: {
        HtmlNode: module17,
        TeXAtom: module18,
        maction: module19,
        maligngroup: module20,
        malignmark: module21,
        math: module22,
        mathchoice: module23,
        menclose: module24,
        merror: module25,
        mfenced: module26,
        mfrac: module27,
        mglyph: module28,
        mi: module29,
        mmultiscripts: module30,
        mn: module31,
        mo: module32,
        mpadded: module33,
        mphantom: module34,
        mroot: module35,
        mrow: module36,
        ms: module37,
        mspace: module38,
        msqrt: module39,
        mstyle: module40,
        msubsup: module41,
        mtable: module42,
        mtd: module43,
        mtext: module44,
        mtr: module45,
        munderover: module46,
        semantics: module47
      },
      MmlVisitor: module48,
      OperatorDictionary: module49,
      SerializedMmlVisitor: module50
    },
    OutputJax: module51,
    Tree: {
      Factory: module52,
      Node: module53,
      NodeFactory: module54,
      Visitor: module55,
      Wrapper: module56,
      WrapperFactory: module57
    }
  },
  handlers: {
    html_ts: module58,
    html: {
      HTMLDocument: module59,
      HTMLDomStrings: module60,
      HTMLHandler: module61,
      HTMLMathItem: module62,
      HTMLMathList: module63
    }
  },
  mathjax: module64,
    util: {
    AsyncLoad: module65,
    BBox: module66,
    BitField: module67,
    Entities: module68,
    FunctionList: module69,
    LinkedList: module70,
    Options: module71,
    PrioritizedList: module72,
    Retries: module73,
    StyleList: module74,
    Styles: module75,
    lengths: module76,
    numeric: module77,
    string: module78
  }
}});
