"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.compatibility = exports.provides = exports.paths = exports.dependencies = void 0;
exports.dependencies = {
    'a11y/semantic-enrich': ['input/mml', 'a11y/sre'],
    'a11y/complexity': ['a11y/semantic-enrich'],
    'a11y/explorer': ['a11y/semantic-enrich', 'ui/menu'],
    '[mml]/mml3': ['input/mml'],
    '[tex]/all-packages': ['input/tex-base'],
    '[tex]/action': ['input/tex-base', '[tex]/newcommand'],
    '[tex]/autoload': ['input/tex-base', '[tex]/require'],
    '[tex]/ams': ['input/tex-base'],
    '[tex]/amscd': ['input/tex-base'],
    '[tex]/bbox': ['input/tex-base', '[tex]/ams', '[tex]/newcommand'],
    '[tex]/boldsymbol': ['input/tex-base'],
    '[tex]/braket': ['input/tex-base'],
    '[tex]/bussproofs': ['input/tex-base'],
    '[tex]/cancel': ['input/tex-base', '[tex]/enclose'],
    '[tex]/centernot': ['input/tex-base'],
    '[tex]/color': ['input/tex-base'],
    '[tex]/colorv2': ['input/tex-base'],
    '[tex]/colortbl': ['input/tex-base', '[tex]/color'],
    '[tex]/configmacros': ['input/tex-base', '[tex]/newcommand'],
    '[tex]/enclose': ['input/tex-base'],
    '[tex]/extpfeil': ['input/tex-base', '[tex]/newcommand', '[tex]/ams'],
    '[tex]/html': ['input/tex-base'],
    '[tex]/mathtools': ['input/tex-base', '[tex]/newcommand', '[tex]/ams'],
    '[tex]/mhchem': ['input/tex-base', '[tex]/ams'],
    '[tex]/newcommand': ['input/tex-base'],
    '[tex]/noerrors': ['input/tex-base'],
    '[tex]/noundefined': ['input/tex-base'],
    '[tex]/physics': ['input/tex-base'],
    '[tex]/require': ['input/tex-base'],
    '[tex]/setoptions': ['input/tex-base'],
    '[tex]/tagformat': ['input/tex-base'],
    '[tex]/texhtml': ['input/tex-base'],
    '[tex]/textcomp': ['input/tex-base', '[tex]/textmacros'],
    '[tex]/textmacros': ['input/tex-base'],
    '[tex]/unicode': ['input/tex-base'],
    '[tex]/verb': ['input/tex-base'],
    '[tex]/cases': ['[tex]/empheq'],
    '[tex]/empheq': ['input/tex-base', '[tex]/ams']
};
exports.paths = {
    tex: '[mathjax]/input/tex/extensions',
    mml: '[mathjax]/input/mml/extensions',
    sre: '[mathjax]/sre/mathmaps'
};
var allPackages = Array.from(Object.keys(exports.dependencies))
    .filter(function (name) { return name.substr(0, 5) === '[tex]' &&
    name !== '[tex]/autoload' &&
    name !== '[tex]/colorv2' &&
    name !== '[tex]/all-packages'; });
exports.provides = {
    'startup': ['loader'],
    'input/tex': [
        'input/tex-base',
        '[tex]/ams',
        '[tex]/newcommand',
        '[tex]/noundefined',
        '[tex]/require',
        '[tex]/autoload',
        '[tex]/configmacros'
    ],
    'input/tex-full': __spreadArray([
        'input/tex-base',
        '[tex]/all-packages'
    ], __read(allPackages), false),
    '[tex]/all-packages': allPackages
};
exports.compatibility = {
    '[tex]/amsCd': '[tex]/amscd',
    '[tex]/colorV2': '[tex]/colorv2',
    '[tex]/configMacros': '[tex]/configmacros',
    '[tex]/tagFormat': '[tex]/tagformat'
};
