"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OutputUtil = exports.FONTPATH = void 0;
var global_js_1 = require("#js/components/global.js");
var package_js_1 = require("#js/components/package.js");
exports.FONTPATH = (typeof document === 'undefined' ?
    '@mathjax/%%FONT%%-font' :
    'https://cdn.jsdelivr.net/npm/%%FONT%%-font');
exports.OutputUtil = {
    config: function (jax, jaxClass, defaultFont, fontClass) {
        var _a, _b, _c, _d, _e;
        if (MathJax.loader) {
            (0, global_js_1.combineDefaults)(MathJax.config, jax, MathJax.config.output || {});
            var config = MathJax.config[jax];
            var font_1 = config.font || defaultFont;
            if (typeof (font_1) !== 'string') {
                config.fontData = font_1;
                config.font = font_1 = font_1.NAME;
            }
            if (font_1.charAt(0) !== '[') {
                var path = (config.fontPath || exports.FONTPATH);
                var name_1 = (font_1.match(/^[a-z]+:/) ? (font_1.match(/[^/:\\]*$/) || [jax])[0] : font_1);
                (0, global_js_1.combineDefaults)(MathJax.config.loader, 'paths', (_a = {},
                    _a[name_1] = (name_1 === font_1 ? path.replace(/%%FONT%%/g, font_1) : font_1),
                    _a));
                font_1 = "[".concat(name_1, "]");
            }
            var name_2 = font_1.substr(1, font_1.length - 2);
            if (name_2 !== defaultFont) {
                (0, global_js_1.combineDefaults)(MathJax.config.loader, "output/".concat(jax), {
                    checkReady: function () {
                        return MathJax.loader.load("".concat(font_1, "/").concat(jax)).catch(function (err) { return console.log(err); });
                    }
                });
            }
            else {
                (0, global_js_1.combineWithMathJax)({ _: {
                        output: {
                            fonts: (_b = {},
                                _b[name_2] = (_c = {},
                                    _c[jax + '_ts'] = (_d = {},
                                        _d[fontClass.NAME + 'Font'] = fontClass,
                                        _d),
                                    _c),
                                _b)
                        }
                    } });
                (0, global_js_1.combineDefaults)(MathJax, 'config', (_e = {
                        output: {
                            font: font_1,
                        }
                    },
                    _e[jax] = {
                        fontData: fontClass,
                        dynamicPrefix: "".concat(font_1, "/").concat(jax, "/dynamic")
                    },
                    _e));
                if (jax === 'chtml') {
                    (0, global_js_1.combineDefaults)(MathJax.config, jax, {
                        fontURL: package_js_1.Package.resolvePath("".concat(font_1, "/").concat(jax, "/woff"), false),
                    });
                }
            }
        }
        if (MathJax.startup) {
            MathJax.startup.registerConstructor(jax, jaxClass);
            MathJax.startup.useOutput(jax);
        }
    },
    loadFont: function (startup, jax, font, preload) {
        if (!MathJax.loader) {
            return Promise.resolve();
        }
        if (preload) {
            MathJax.loader.preLoad("[".concat(font, "]/").concat(jax));
        }
        var check = MathJax.config.loader["output/".concat(jax)];
        var start = (check && check.checkReady ? check.checkReady().then(startup) : startup());
        return start.catch(function (err) { return console.log(err); });
    }
};
