const {combineWithMathJax} = require('../../../../../cjs/components/global.js')
const {VERSION} = require('../../../../../cjs/components/version.js');

const module1 = require('../../../../../cjs/ui/menu/AnnotationMenu.js');
const module2 = require('../../../../../cjs/ui/menu/MJContextMenu.js');
const module3 = require('../../../../../cjs/ui/menu/Menu.js');
const module4 = require('../../../../../cjs/ui/menu/MenuHandler.js');
const module5 = require('../../../../../cjs/ui/menu/MenuUtil.js');
const module6 = require('../../../../../cjs/ui/menu/MmlVisitor.js');
const module7 = require('../../../../../cjs/ui/menu/RadioCompare.js');
const module8 = require('../../../../../cjs/ui/menu/SelectableInfo.js');

if (MathJax.loader) {
  MathJax.loader.checkVersion('ui/menu', VERSION, 'ui');
}

combineWithMathJax({_: {
  ui: {
    menu: {
      AnnotationMenu: module1,
      MJContextMenu: module2,
      Menu: module3,
      MenuHandler: module4,
      MenuUtil: module5,
      MmlVisitor: module6,
      RadioCompare: module7,
      SelectableInfo: module8
    }
  }
}});
