import {combineWithMathJax} from '../../../../mjs/components/global.js';
import {VERSION} from '../../../../mjs/components/version.js';

import * as module1 from '../../../../mjs/adaptors/HTMLAdaptor.js';
import * as module2 from '../../../../mjs/adaptors/browserAdaptor.js';
import * as module3 from '../../../../mjs/components/global.js';
import * as module4 from '../../../../mjs/core/DOMAdaptor.js';
import * as module5 from '../../../../mjs/core/FindMath.js';
import * as module6 from '../../../../mjs/core/Handler.js';
import * as module7 from '../../../../mjs/core/HandlerList.js';
import * as module8 from '../../../../mjs/core/InputJax.js';
import * as module9 from '../../../../mjs/core/MathDocument.js';
import * as module10 from '../../../../mjs/core/MathItem.js';
import * as module11 from '../../../../mjs/core/MathList.js';
import * as module12 from '../../../../mjs/core/MmlTree/Attributes.js';
import * as module13 from '../../../../mjs/core/MmlTree/MML.js';
import * as module14 from '../../../../mjs/core/MmlTree/MathMLVisitor.js';
import * as module15 from '../../../../mjs/core/MmlTree/MmlFactory.js';
import * as module16 from '../../../../mjs/core/MmlTree/MmlNode.js';
import * as module17 from '../../../../mjs/core/MmlTree/MmlNodes/HtmlNode.js';
import * as module18 from '../../../../mjs/core/MmlTree/MmlNodes/TeXAtom.js';
import * as module19 from '../../../../mjs/core/MmlTree/MmlNodes/maction.js';
import * as module20 from '../../../../mjs/core/MmlTree/MmlNodes/maligngroup.js';
import * as module21 from '../../../../mjs/core/MmlTree/MmlNodes/malignmark.js';
import * as module22 from '../../../../mjs/core/MmlTree/MmlNodes/math.js';
import * as module23 from '../../../../mjs/core/MmlTree/MmlNodes/mathchoice.js';
import * as module24 from '../../../../mjs/core/MmlTree/MmlNodes/menclose.js';
import * as module25 from '../../../../mjs/core/MmlTree/MmlNodes/merror.js';
import * as module26 from '../../../../mjs/core/MmlTree/MmlNodes/mfenced.js';
import * as module27 from '../../../../mjs/core/MmlTree/MmlNodes/mfrac.js';
import * as module28 from '../../../../mjs/core/MmlTree/MmlNodes/mglyph.js';
import * as module29 from '../../../../mjs/core/MmlTree/MmlNodes/mi.js';
import * as module30 from '../../../../mjs/core/MmlTree/MmlNodes/mmultiscripts.js';
import * as module31 from '../../../../mjs/core/MmlTree/MmlNodes/mn.js';
import * as module32 from '../../../../mjs/core/MmlTree/MmlNodes/mo.js';
import * as module33 from '../../../../mjs/core/MmlTree/MmlNodes/mpadded.js';
import * as module34 from '../../../../mjs/core/MmlTree/MmlNodes/mphantom.js';
import * as module35 from '../../../../mjs/core/MmlTree/MmlNodes/mroot.js';
import * as module36 from '../../../../mjs/core/MmlTree/MmlNodes/mrow.js';
import * as module37 from '../../../../mjs/core/MmlTree/MmlNodes/ms.js';
import * as module38 from '../../../../mjs/core/MmlTree/MmlNodes/mspace.js';
import * as module39 from '../../../../mjs/core/MmlTree/MmlNodes/msqrt.js';
import * as module40 from '../../../../mjs/core/MmlTree/MmlNodes/mstyle.js';
import * as module41 from '../../../../mjs/core/MmlTree/MmlNodes/msubsup.js';
import * as module42 from '../../../../mjs/core/MmlTree/MmlNodes/mtable.js';
import * as module43 from '../../../../mjs/core/MmlTree/MmlNodes/mtd.js';
import * as module44 from '../../../../mjs/core/MmlTree/MmlNodes/mtext.js';
import * as module45 from '../../../../mjs/core/MmlTree/MmlNodes/mtr.js';
import * as module46 from '../../../../mjs/core/MmlTree/MmlNodes/munderover.js';
import * as module47 from '../../../../mjs/core/MmlTree/MmlNodes/semantics.js';
import * as module48 from '../../../../mjs/core/MmlTree/MmlVisitor.js';
import * as module49 from '../../../../mjs/core/MmlTree/OperatorDictionary.js';
import * as module50 from '../../../../mjs/core/MmlTree/SerializedMmlVisitor.js';
import * as module51 from '../../../../mjs/core/OutputJax.js';
import * as module52 from '../../../../mjs/core/Tree/Factory.js';
import * as module53 from '../../../../mjs/core/Tree/Node.js';
import * as module54 from '../../../../mjs/core/Tree/NodeFactory.js';
import * as module55 from '../../../../mjs/core/Tree/Visitor.js';
import * as module56 from '../../../../mjs/core/Tree/Wrapper.js';
import * as module57 from '../../../../mjs/core/Tree/WrapperFactory.js';
import * as module58 from '../../../../mjs/handlers/html.js';
import * as module59 from '../../../../mjs/handlers/html/HTMLDocument.js';
import * as module60 from '../../../../mjs/handlers/html/HTMLDomStrings.js';
import * as module61 from '../../../../mjs/handlers/html/HTMLHandler.js';
import * as module62 from '../../../../mjs/handlers/html/HTMLMathItem.js';
import * as module63 from '../../../../mjs/handlers/html/HTMLMathList.js';
import * as module64 from '../../../../mjs/mathjax.js';
import * as module65 from '../../../../mjs/util/AsyncLoad.js';
import * as module66 from '../../../../mjs/util/BBox.js';
import * as module67 from '../../../../mjs/util/BitField.js';
import * as module68 from '../../../../mjs/util/Entities.js';
import * as module69 from '../../../../mjs/util/FunctionList.js';
import * as module70 from '../../../../mjs/util/LinkedList.js';
import * as module71 from '../../../../mjs/util/Options.js';
import * as module72 from '../../../../mjs/util/PrioritizedList.js';
import * as module73 from '../../../../mjs/util/Retries.js';
import * as module74 from '../../../../mjs/util/StyleList.js';
import * as module75 from '../../../../mjs/util/Styles.js';
import * as module76 from '../../../../mjs/util/lengths.js';
import * as module77 from '../../../../mjs/util/numeric.js';
import * as module78 from '../../../../mjs/util/string.js';

if (MathJax.loader) {
  MathJax.loader.checkVersion('core', VERSION, 'core');
}

combineWithMathJax({_: {
  adaptors: {
    HTMLAdaptor: module1,
    browserAdaptor: module2
  },
  components: {
    global: module3
  },
  core: {
    DOMAdaptor: module4,
    FindMath: module5,
    Handler: module6,
    HandlerList: module7,
    InputJax: module8,
    MathDocument: module9,
    MathItem: module10,
    MathList: module11,
    MmlTree: {
      Attributes: module12,
      MML: module13,
      MathMLVisitor: module14,
      MmlFactory: module15,
      MmlNode: module16,
      MmlNodes: {
        HtmlNode: module17,
        TeXAtom: module18,
        maction: module19,
        maligngroup: module20,
        malignmark: module21,
        math: module22,
        mathchoice: module23,
        menclose: module24,
        merror: module25,
        mfenced: module26,
        mfrac: module27,
        mglyph: module28,
        mi: module29,
        mmultiscripts: module30,
        mn: module31,
        mo: module32,
        mpadded: module33,
        mphantom: module34,
        mroot: module35,
        mrow: module36,
        ms: module37,
        mspace: module38,
        msqrt: module39,
        mstyle: module40,
        msubsup: module41,
        mtable: module42,
        mtd: module43,
        mtext: module44,
        mtr: module45,
        munderover: module46,
        semantics: module47
      },
      MmlVisitor: module48,
      OperatorDictionary: module49,
      SerializedMmlVisitor: module50
    },
    OutputJax: module51,
    Tree: {
      Factory: module52,
      Node: module53,
      NodeFactory: module54,
      Visitor: module55,
      Wrapper: module56,
      WrapperFactory: module57
    }
  },
  handlers: {
    html_ts: module58,
    html: {
      HTMLDocument: module59,
      HTMLDomStrings: module60,
      HTMLHandler: module61,
      HTMLMathItem: module62,
      HTMLMathList: module63
    }
  },
  mathjax: module64,
    util: {
    AsyncLoad: module65,
    BBox: module66,
    BitField: module67,
    Entities: module68,
    FunctionList: module69,
    LinkedList: module70,
    Options: module71,
    PrioritizedList: module72,
    Retries: module73,
    StyleList: module74,
    Styles: module75,
    lengths: module76,
    numeric: module77,
    string: module78
  }
}});
