import {combineWithMathJax} from '../../../../../mjs/components/global.js';
import {VERSION} from '../../../../../mjs/components/version.js';

import * as module1 from '../../../../../mjs/input/tex.js';
import * as module2 from '../../../../../mjs/input/tex/AllPackages.js';
import * as module3 from '../../../../../mjs/input/tex/ColumnParser.js';
import * as module4 from '../../../../../mjs/input/tex/Configuration.js';
import * as module5 from '../../../../../mjs/input/tex/FilterUtil.js';
import * as module6 from '../../../../../mjs/input/tex/FindTeX.js';
import * as module7 from '../../../../../mjs/input/tex/MapHandler.js';
import * as module8 from '../../../../../mjs/input/tex/NodeFactory.js';
import * as module9 from '../../../../../mjs/input/tex/NodeUtil.js';
import * as module10 from '../../../../../mjs/input/tex/ParseMethods.js';
import * as module11 from '../../../../../mjs/input/tex/ParseOptions.js';
import * as module12 from '../../../../../mjs/input/tex/ParseUtil.js';
import * as module13 from '../../../../../mjs/input/tex/Stack.js';
import * as module14 from '../../../../../mjs/input/tex/StackItem.js';
import * as module15 from '../../../../../mjs/input/tex/StackItemFactory.js';
import * as module16 from '../../../../../mjs/input/tex/Tags.js';
import * as module17 from '../../../../../mjs/input/tex/TexConstants.js';
import * as module18 from '../../../../../mjs/input/tex/TexError.js';
import * as module19 from '../../../../../mjs/input/tex/TexParser.js';
import * as module20 from '../../../../../mjs/input/tex/Token.js';
import * as module21 from '../../../../../mjs/input/tex/TokenMap.js';
import * as module22 from '../../../../../mjs/input/tex/action/ActionConfiguration.js';
import * as module23 from '../../../../../mjs/input/tex/amscd/AmsCdConfiguration.js';
import * as module24 from '../../../../../mjs/input/tex/amscd/AmsCdMethods.js';
import * as module25 from '../../../../../mjs/input/tex/ams/AmsConfiguration.js';
import * as module26 from '../../../../../mjs/input/tex/ams/AmsItems.js';
import * as module27 from '../../../../../mjs/input/tex/ams/AmsMethods.js';
import * as module28 from '../../../../../mjs/input/tex/autoload/AutoloadConfiguration.js';
import * as module29 from '../../../../../mjs/input/tex/base/BaseConfiguration.js';
import * as module30 from '../../../../../mjs/input/tex/base/BaseItems.js';
import * as module31 from '../../../../../mjs/input/tex/base/BaseMethods.js';
import * as module32 from '../../../../../mjs/input/tex/bbox/BboxConfiguration.js';
import * as module33 from '../../../../../mjs/input/tex/boldsymbol/BoldsymbolConfiguration.js';
import * as module34 from '../../../../../mjs/input/tex/braket/BraketConfiguration.js';
import * as module35 from '../../../../../mjs/input/tex/braket/BraketItems.js';
import * as module36 from '../../../../../mjs/input/tex/braket/BraketMethods.js';
import * as module37 from '../../../../../mjs/input/tex/bussproofs/BussproofsConfiguration.js';
import * as module38 from '../../../../../mjs/input/tex/bussproofs/BussproofsItems.js';
import * as module39 from '../../../../../mjs/input/tex/bussproofs/BussproofsMethods.js';
import * as module40 from '../../../../../mjs/input/tex/bussproofs/BussproofsUtil.js';
import * as module41 from '../../../../../mjs/input/tex/cancel/CancelConfiguration.js';
import * as module42 from '../../../../../mjs/input/tex/cases/CasesConfiguration.js';
import * as module43 from '../../../../../mjs/input/tex/centernot/CenternotConfiguration.js';
import * as module44 from '../../../../../mjs/input/tex/colortbl/ColortblConfiguration.js';
import * as module45 from '../../../../../mjs/input/tex/colorv2/ColorV2Configuration.js';
import * as module46 from '../../../../../mjs/input/tex/color/ColorConfiguration.js';
import * as module47 from '../../../../../mjs/input/tex/color/ColorConstants.js';
import * as module48 from '../../../../../mjs/input/tex/color/ColorMethods.js';
import * as module49 from '../../../../../mjs/input/tex/color/ColorUtil.js';
import * as module50 from '../../../../../mjs/input/tex/configmacros/ConfigMacrosConfiguration.js';
import * as module51 from '../../../../../mjs/input/tex/empheq/EmpheqConfiguration.js';
import * as module52 from '../../../../../mjs/input/tex/empheq/EmpheqUtil.js';
import * as module53 from '../../../../../mjs/input/tex/enclose/EncloseConfiguration.js';
import * as module54 from '../../../../../mjs/input/tex/extpfeil/ExtpfeilConfiguration.js';
import * as module55 from '../../../../../mjs/input/tex/gensymb/GensymbConfiguration.js';
import * as module56 from '../../../../../mjs/input/tex/html/HtmlConfiguration.js';
import * as module57 from '../../../../../mjs/input/tex/html/HtmlMethods.js';
import * as module58 from '../../../../../mjs/input/tex/mathtools/MathtoolsConfiguration.js';
import * as module59 from '../../../../../mjs/input/tex/mathtools/MathtoolsItems.js';
import * as module60 from '../../../../../mjs/input/tex/mathtools/MathtoolsMethods.js';
import * as module61 from '../../../../../mjs/input/tex/mathtools/MathtoolsTags.js';
import * as module62 from '../../../../../mjs/input/tex/mathtools/MathtoolsUtil.js';
import * as module63 from '../../../../../mjs/input/tex/mhchem/MhchemConfiguration.js';
import * as module64 from '../../../../../mjs/input/tex/newcommand/NewcommandConfiguration.js';
import * as module65 from '../../../../../mjs/input/tex/newcommand/NewcommandItems.js';
import * as module66 from '../../../../../mjs/input/tex/newcommand/NewcommandMethods.js';
import * as module67 from '../../../../../mjs/input/tex/newcommand/NewcommandUtil.js';
import * as module68 from '../../../../../mjs/input/tex/noerrors/NoErrorsConfiguration.js';
import * as module69 from '../../../../../mjs/input/tex/noundefined/NoUndefinedConfiguration.js';
import * as module70 from '../../../../../mjs/input/tex/physics/PhysicsConfiguration.js';
import * as module71 from '../../../../../mjs/input/tex/physics/PhysicsItems.js';
import * as module72 from '../../../../../mjs/input/tex/physics/PhysicsMethods.js';
import * as module73 from '../../../../../mjs/input/tex/require/RequireConfiguration.js';
import * as module74 from '../../../../../mjs/input/tex/setoptions/SetOptionsConfiguration.js';
import * as module75 from '../../../../../mjs/input/tex/tagformat/TagFormatConfiguration.js';
import * as module76 from '../../../../../mjs/input/tex/texhtml/TexHtmlConfiguration.js';
import * as module77 from '../../../../../mjs/input/tex/textcomp/TextcompConfiguration.js';
import * as module78 from '../../../../../mjs/input/tex/textmacros/TextMacrosConfiguration.js';
import * as module79 from '../../../../../mjs/input/tex/textmacros/TextMacrosMethods.js';
import * as module80 from '../../../../../mjs/input/tex/textmacros/TextParser.js';
import * as module81 from '../../../../../mjs/input/tex/unicode/UnicodeConfiguration.js';
import * as module82 from '../../../../../mjs/input/tex/units/UnitsConfiguration.js';
import * as module83 from '../../../../../mjs/input/tex/upgreek/UpgreekConfiguration.js';
import * as module84 from '../../../../../mjs/input/tex/verb/VerbConfiguration.js';

if (MathJax.loader) {
  MathJax.loader.checkVersion('input/tex-full', VERSION, 'input');
}

combineWithMathJax({_: {
  input: {
    tex_ts: module1,
    tex: {
      AllPackages: module2,
      ColumnParser: module3,
      Configuration: module4,
      FilterUtil: module5,
      FindTeX: module6,
      MapHandler: module7,
      NodeFactory: module8,
      NodeUtil: module9,
      ParseMethods: module10,
      ParseOptions: module11,
      ParseUtil: module12,
      Stack: module13,
      StackItem: module14,
      StackItemFactory: module15,
      Tags: module16,
      TexConstants: module17,
      TexError: module18,
      TexParser: module19,
      Token: module20,
      TokenMap: module21,
      action: {
        ActionConfiguration: module22
      },
      amscd: {
        AmsCdConfiguration: module23,
        AmsCdMethods: module24
      },
      ams: {
        AmsConfiguration: module25,
        AmsItems: module26,
        AmsMethods: module27
      },
      autoload: {
        AutoloadConfiguration: module28
      },
      base: {
        BaseConfiguration: module29,
        BaseItems: module30,
        BaseMethods: module31
      },
      bbox: {
        BboxConfiguration: module32
      },
      boldsymbol: {
        BoldsymbolConfiguration: module33
      },
      braket: {
        BraketConfiguration: module34,
        BraketItems: module35,
        BraketMethods: module36
      },
      bussproofs: {
        BussproofsConfiguration: module37,
        BussproofsItems: module38,
        BussproofsMethods: module39,
        BussproofsUtil: module40
      },
      cancel: {
        CancelConfiguration: module41
      },
      cases: {
        CasesConfiguration: module42
      },
      centernot: {
        CenternotConfiguration: module43
      },
      colortbl: {
        ColortblConfiguration: module44
      },
      colorv2: {
        ColorV2Configuration: module45
      },
      color: {
        ColorConfiguration: module46,
        ColorConstants: module47,
        ColorMethods: module48,
        ColorUtil: module49
      },
      configmacros: {
        ConfigMacrosConfiguration: module50
      },
      empheq: {
        EmpheqConfiguration: module51,
        EmpheqUtil: module52
      },
      enclose: {
        EncloseConfiguration: module53
      },
      extpfeil: {
        ExtpfeilConfiguration: module54
      },
      gensymb: {
        GensymbConfiguration: module55
      },
      html: {
        HtmlConfiguration: module56,
        HtmlMethods: module57
      },
      mathtools: {
        MathtoolsConfiguration: module58,
        MathtoolsItems: module59,
        MathtoolsMethods: module60,
        MathtoolsTags: module61,
        MathtoolsUtil: module62
      },
      mhchem: {
        MhchemConfiguration: module63
      },
      newcommand: {
        NewcommandConfiguration: module64,
        NewcommandItems: module65,
        NewcommandMethods: module66,
        NewcommandUtil: module67
      },
      noerrors: {
        NoErrorsConfiguration: module68
      },
      noundefined: {
        NoUndefinedConfiguration: module69
      },
      physics: {
        PhysicsConfiguration: module70,
        PhysicsItems: module71,
        PhysicsMethods: module72
      },
      require: {
        RequireConfiguration: module73
      },
      setoptions: {
        SetOptionsConfiguration: module74
      },
      tagformat: {
        TagFormatConfiguration: module75
      },
      texhtml: {
        TexHtmlConfiguration: module76
      },
      textcomp: {
        TextcompConfiguration: module77
      },
      textmacros: {
        TextMacrosConfiguration: module78,
        TextMacrosMethods: module79,
        TextParser: module80
      },
      unicode: {
        UnicodeConfiguration: module81
      },
      units: {
        UnitsConfiguration: module82
      },
      upgreek: {
        UpgreekConfiguration: module83
      },
      verb: {
        VerbConfiguration: module84
      }
    }
  }
}});
