import {combineWithMathJax} from '../../../../../../../mjs/components/global.js';
import {VERSION} from '../../../../../../../mjs/components/version.js';

import * as module1 from '../../../../../../../mjs/input/tex/AllPackages.js';
import * as module2 from '../../../../../../../mjs/input/tex/autoload/AutoloadConfiguration.js';
import * as module3 from '../../../../../../../mjs/input/tex/require/RequireConfiguration.js';

if (MathJax.loader) {
  MathJax.loader.checkVersion('[tex]/all-packages', VERSION, 'tex-extension');
}

combineWithMathJax({_: {
  input: {
    tex: {
      AllPackages: module1,
      autoload: {
        AutoloadConfiguration: module2
      },
      require: {
        RequireConfiguration: module3
      }
    }
  }
}});
