import {combineWithMathJax} from '../../../../../mjs/components/global.js';
import {VERSION} from '../../../../../mjs/components/version.js';

import * as module1 from '../../../../../mjs/output/common/Direction.js';
import * as module2 from '../../../../../mjs/output/common/FontData.js';
import * as module3 from '../../../../../mjs/output/common/LineBBox.js';
import * as module4 from '../../../../../mjs/output/common/LinebreakVisitor.js';
import * as module5 from '../../../../../mjs/output/common/Notation.js';
import * as module6 from '../../../../../mjs/output/common/Wrapper.js';
import * as module7 from '../../../../../mjs/output/common/WrapperFactory.js';
import * as module8 from '../../../../../mjs/output/common/Wrappers/HtmlNode.js';
import * as module9 from '../../../../../mjs/output/common/Wrappers/TeXAtom.js';
import * as module10 from '../../../../../mjs/output/common/Wrappers/TextNode.js';
import * as module11 from '../../../../../mjs/output/common/Wrappers/maction.js';
import * as module12 from '../../../../../mjs/output/common/Wrappers/math.js';
import * as module13 from '../../../../../mjs/output/common/Wrappers/menclose.js';
import * as module14 from '../../../../../mjs/output/common/Wrappers/mfenced.js';
import * as module15 from '../../../../../mjs/output/common/Wrappers/mfrac.js';
import * as module16 from '../../../../../mjs/output/common/Wrappers/mglyph.js';
import * as module17 from '../../../../../mjs/output/common/Wrappers/mi.js';
import * as module18 from '../../../../../mjs/output/common/Wrappers/mmultiscripts.js';
import * as module19 from '../../../../../mjs/output/common/Wrappers/mn.js';
import * as module20 from '../../../../../mjs/output/common/Wrappers/mo.js';
import * as module21 from '../../../../../mjs/output/common/Wrappers/mpadded.js';
import * as module22 from '../../../../../mjs/output/common/Wrappers/mroot.js';
import * as module23 from '../../../../../mjs/output/common/Wrappers/mrow.js';
import * as module24 from '../../../../../mjs/output/common/Wrappers/ms.js';
import * as module25 from '../../../../../mjs/output/common/Wrappers/mspace.js';
import * as module26 from '../../../../../mjs/output/common/Wrappers/msqrt.js';
import * as module27 from '../../../../../mjs/output/common/Wrappers/msubsup.js';
import * as module28 from '../../../../../mjs/output/common/Wrappers/mtable.js';
import * as module29 from '../../../../../mjs/output/common/Wrappers/mtd.js';
import * as module30 from '../../../../../mjs/output/common/Wrappers/mtext.js';
import * as module31 from '../../../../../mjs/output/common/Wrappers/mtr.js';
import * as module32 from '../../../../../mjs/output/common/Wrappers/munderover.js';
import * as module33 from '../../../../../mjs/output/common/Wrappers/scriptbase.js';
import * as module34 from '../../../../../mjs/output/common/Wrappers/semantics.js';
import * as module35 from '../../../../../mjs/output/svg.js';
import * as module36 from '../../../../../mjs/output/svg/DefaultFont.js';
import * as module37 from '../../../../../mjs/output/svg/FontCache.js';
import * as module38 from '../../../../../mjs/output/svg/FontData.js';
import * as module39 from '../../../../../mjs/output/svg/Notation.js';
import * as module40 from '../../../../../mjs/output/svg/Wrapper.js';
import * as module41 from '../../../../../mjs/output/svg/WrapperFactory.js';
import * as module42 from '../../../../../mjs/output/svg/Wrappers.js';
import * as module43 from '../../../../../mjs/output/svg/Wrappers/HtmlNode.js';
import * as module44 from '../../../../../mjs/output/svg/Wrappers/TeXAtom.js';
import * as module45 from '../../../../../mjs/output/svg/Wrappers/TextNode.js';
import * as module46 from '../../../../../mjs/output/svg/Wrappers/maction.js';
import * as module47 from '../../../../../mjs/output/svg/Wrappers/math.js';
import * as module48 from '../../../../../mjs/output/svg/Wrappers/menclose.js';
import * as module49 from '../../../../../mjs/output/svg/Wrappers/merror.js';
import * as module50 from '../../../../../mjs/output/svg/Wrappers/mfenced.js';
import * as module51 from '../../../../../mjs/output/svg/Wrappers/mfrac.js';
import * as module52 from '../../../../../mjs/output/svg/Wrappers/mglyph.js';
import * as module53 from '../../../../../mjs/output/svg/Wrappers/mi.js';
import * as module54 from '../../../../../mjs/output/svg/Wrappers/mmultiscripts.js';
import * as module55 from '../../../../../mjs/output/svg/Wrappers/mn.js';
import * as module56 from '../../../../../mjs/output/svg/Wrappers/mo.js';
import * as module57 from '../../../../../mjs/output/svg/Wrappers/mpadded.js';
import * as module58 from '../../../../../mjs/output/svg/Wrappers/mphantom.js';
import * as module59 from '../../../../../mjs/output/svg/Wrappers/mroot.js';
import * as module60 from '../../../../../mjs/output/svg/Wrappers/mrow.js';
import * as module61 from '../../../../../mjs/output/svg/Wrappers/ms.js';
import * as module62 from '../../../../../mjs/output/svg/Wrappers/mspace.js';
import * as module63 from '../../../../../mjs/output/svg/Wrappers/msqrt.js';
import * as module64 from '../../../../../mjs/output/svg/Wrappers/msubsup.js';
import * as module65 from '../../../../../mjs/output/svg/Wrappers/mtable.js';
import * as module66 from '../../../../../mjs/output/svg/Wrappers/mtd.js';
import * as module67 from '../../../../../mjs/output/svg/Wrappers/mtext.js';
import * as module68 from '../../../../../mjs/output/svg/Wrappers/mtr.js';
import * as module69 from '../../../../../mjs/output/svg/Wrappers/munderover.js';
import * as module70 from '../../../../../mjs/output/svg/Wrappers/scriptbase.js';
import * as module71 from '../../../../../mjs/output/svg/Wrappers/semantics.js';
import * as module72 from '../../../../../mjs/output/svg/Wrappers/zero.js';

if (MathJax.loader) {
  MathJax.loader.checkVersion('output/svg', VERSION, 'output');
}

combineWithMathJax({_: {
  output: {
    common: {
      Direction: module1,
      FontData: module2,
      LineBBox: module3,
      LinebreakVisitor: module4,
      Notation: module5,
      Wrapper: module6,
      WrapperFactory: module7,
      Wrappers: {
        HtmlNode: module8,
        TeXAtom: module9,
        TextNode: module10,
        maction: module11,
        math: module12,
        menclose: module13,
        mfenced: module14,
        mfrac: module15,
        mglyph: module16,
        mi: module17,
        mmultiscripts: module18,
        mn: module19,
        mo: module20,
        mpadded: module21,
        mroot: module22,
        mrow: module23,
        ms: module24,
        mspace: module25,
        msqrt: module26,
        msubsup: module27,
        mtable: module28,
        mtd: module29,
        mtext: module30,
        mtr: module31,
        munderover: module32,
        scriptbase: module33,
        semantics: module34
      }
    },
    svg_ts: module35,
    svg: {
      DefaultFont: module36,
      FontCache: module37,
      FontData: module38,
      Notation: module39,
      Wrapper: module40,
      WrapperFactory: module41,
      Wrappers_ts: module42,
      Wrappers: {
        HtmlNode: module43,
        TeXAtom: module44,
        TextNode: module45,
        maction: module46,
        math: module47,
        menclose: module48,
        merror: module49,
        mfenced: module50,
        mfrac: module51,
        mglyph: module52,
        mi: module53,
        mmultiscripts: module54,
        mn: module55,
        mo: module56,
        mpadded: module57,
        mphantom: module58,
        mroot: module59,
        mrow: module60,
        ms: module61,
        mspace: module62,
        msqrt: module63,
        msubsup: module64,
        mtable: module65,
        mtd: module66,
        mtext: module67,
        mtr: module68,
        munderover: module69,
        scriptbase: module70,
        semantics: module71,
        zero: module72
      }
    }
  }
}});
