import {combineWithMathJax} from '../../../../../mjs/components/global.js';
import {VERSION} from '../../../../../mjs/components/version.js';

import * as module1 from '../../../../../mjs/ui/menu/AnnotationMenu.js';
import * as module2 from '../../../../../mjs/ui/menu/MJContextMenu.js';
import * as module3 from '../../../../../mjs/ui/menu/Menu.js';
import * as module4 from '../../../../../mjs/ui/menu/MenuHandler.js';
import * as module5 from '../../../../../mjs/ui/menu/MenuUtil.js';
import * as module6 from '../../../../../mjs/ui/menu/MmlVisitor.js';
import * as module7 from '../../../../../mjs/ui/menu/RadioCompare.js';
import * as module8 from '../../../../../mjs/ui/menu/SelectableInfo.js';

if (MathJax.loader) {
  MathJax.loader.checkVersion('ui/menu', VERSION, 'ui');
}

combineWithMathJax({_: {
  ui: {
    menu: {
      AnnotationMenu: module1,
      MJContextMenu: module2,
      Menu: module3,
      MenuHandler: module4,
      MenuUtil: module5,
      MmlVisitor: module6,
      RadioCompare: module7,
      SelectableInfo: module8
    }
  }
}});
